#INCLUDE ONCE "fbgfx.bi"
USING FB

#INCLIB "joypad"
#INCLUDE ONCE "joypad.bi"

'sound stuff
#INCLUDE ONCE "fmod_object.bi"
#INCLUDE ONCE "fmod_object.bas"
DIM SHARED AS fmod_ mysound

'some useful macro/function/whatever thingy
#IFNDEF TRUE
CONST FALSE = 0
CONST TRUE = NOT FALSE
#ENDIF

#IFNDEF zerofill
#define ZEROFILL(VARNAME, NUMDIGIT) (RIGHT(STRING(NUMDIGIT - 1, "0" ) & VARNAME, NUMDIGIT))
#ENDIF
#IFNDEF spacefill
#DEFINE spaceFILL(VARNAME, NUMDIGIT) (RIGHT(STRING(NUMDIGIT - 1, " " ) & VARNAME, NUMDIGIT))
#ENDIF
#IFNDEF minusfill
#DEFINE minusFILL(VARNAME, NUMDIGIT) (RIGHT(STRING(NUMDIGIT - 1, "-" ) & VARNAME, NUMDIGIT))
#ENDIF
#IFNDEF convertSTR
#DEFINE convertSTR(s,nth) VALINT(MID((s), nth)) 'trim first nth letters from string then convert to integer.
#ENDIF

'chara list that uses Y sort for displaying
#DEFINE player_slot          ( 0)
#DEFINE key_slot             ( 1)
#DEFINE max_object_limit     (36)
#DEFINE max_people_limit     (17)
#DEFINE max_food_limit       (max_object_limit + max_people_limit-1)
#DEFINE max_projectile_limit (max_people_limit)

CONST AS INTEGER object_min_bound      = 2
CONST AS INTEGER object_max_bound      = object_min_bound + (max_object_limit-1)
CONST AS INTEGER people_min_bound      = object_max_bound + 1
CONST AS INTEGER people_max_bound      = people_min_bound + (max_people_limit-1)
CONST AS INTEGER food_min_bound        = people_max_bound + 1
CONST AS INTEGER food_max_bound        = food_min_bound + (max_food_limit-1)
CONST AS INTEGER projectile_min_bound  = food_max_bound + 1
CONST AS INTEGER projectile_max_bound  = projectile_min_bound + (max_projectile_limit-1)
CONST AS INTEGER changev_slot          = projectile_max_bound + 1
CONST AS INTEGER max_every_stuff_limit = changev_slot

#DEFINE rare_1up_ratio   15
#DEFINE rare_apple_ratio  5

#DEFINE slime_speed  2
#DEFINE people_speed 1

#DEFINE max_trail_limit (40)
#DEFINE max_spark_limit 32

#DEFINE ring_style_trail ' less trail calculation

#DEFINE attack_pause 30
#DEFINE attack_end   (attack_pause+30)
#DEFINE jump_step 90

#DEFINE FINETUNE (2)

#DEFINE tree_object      256 'broken object = +8 position
#DEFINE barrel_object    257
#DEFINE sign_object      258
#DEFINE well_object      259
#DEFINE cross_object     260
#DEFINE tombstone_object 261
#DEFINE mailbox_object   262
#DEFINE jar_object       263

#DEFINE rock_object      272 'next line

#DEFINE door_object        274 'next line
#DEFINE hole_big_object    275
#DEFINE hole_small_object  276
#DEFINE hole_window_object 277  '--
#DEFINE tri_roof_l_object  278
#DEFINE tri_roof_r_object  279

#DEFINE rom_window_object    288   '--
#DEFINE rom_door_object      289
#DEFINE cookie_window_object 290    '--
#DEFINE cookie_wall_object   291
#DEFINE cookie_door_object   292
#DEFINE castle_door_l_object 293
#DEFINE castle_door_r_object 294
#DEFINE castle_wall_object   295

#DEFINE invalid_object   309 'last element
#DEFINE helper_object    317 'last element

'--- enum ------------------------
ENUM slime_state
slime_state_init = 0     'new game initialization stuff. maybe not.
slime_state_cutscene    'cut scene between towns.
slime_state_load_town    '
slime_state_enter_town   'walk into town from outside of screen.
slime_state_ready        'misc. reset some stuff just before the player starts walking around.
slime_state_normal       'user control part
slime_state_eacape_town  'run out of town then set next map x,y. (next town)
slime_state_advance_next 'loading map @ mapx,y too then set to init.
slime_state_wait_before_cutscene
slime_state_key_get      'will open door. thats all. may be... not used at all.
slime_state_time_over    'will open door. thats all. may be... not used at all.
slime_state_zomg         'sline is shoked. ZOMG!!
slime_state_im_home      'slime talking I'm home!
slime_state_splat        'after slime talking I'm home!
slime_state_dying        'final dying animation
slime_state_dead         'after dead, set to slime_state_prepare_town or
slime_state_after_death
END ENUM

ENUM people_state
people_state_init = 0       'new game initialization stuff. maybe not.
people_state_decide_walking 'distance and direction...
people_state_walking        '
people_state_shake          ' hit by punch. shake a bit.
people_state_shock          ' step on some shocking stuff will stun people.
people_state_falldown       ' hp 0 state.
people_state_dead           ' dead!


chv_state_outside = 0
chv_state_open_door
chv_state_walk_in
chv_state_found_you
chv_state_jump
chv_state_stomp
chv_state_won
chv_state_waiting_for_cutscene
chv_state_hiding
chv_state_waiting

END ENUM


ENUM direction
from_top = 0
from_right
from_bottom
from_left
at_the_zoo

facing_up = 0
facing_right
facing_down
facing_left

joy_up = 1
joy_upper_right
joy_right
joy_lower_right
joy_down
joy_lower_left
joy_left
joy_upper_left
END ENUM

ENUM various_type
start_game = 1 'is this used???
arena_game = 2
quit_game  = 3

'chara's type (that uses Y-sort for displaying)
player_type = 01
key_type
object_type
people_type
food_type
projectile_type
changev_type

'5 door state
door_opened = 0 '   walkable. no door
DOOR_LOCKED     'no walkable. locked
door_blocked    'no walkable. blue block

'door direction
top_door    = &h01
right_door  = &h02
bottom_door = &h04
left_door   = &h08
zoo_door    = &h10

'used in walkable grid
walkable_grid     = 0  'walkable
opened_door       = 0
locked_door       = 1  'openable
blocked_door      = 2  'non walkable
blocked_grid      = 2
non_walkable_grid = 2


not_attacking = 0 ' slime action state
punching          ' slime action state

punch_forward     'punching state
punch_hold
punch_retract

punch_ready       'some other unused(yet) state

'for medal message.
message_off = 0
medal_none = 0
medal_get_key
medal_kill_10_male
medal_kill_10_female
medal_kill_10_knight
medal_MiniRPG
medal_find_candy
medal_break_99_object
medal_no_miss

'spark particle type
spark_sun  = 0
spark_dia
spark_star 'not used
spark_puff 'not used

'food sprite/tile number. also used in foodtype selection
food_coin     = 310
food_apple    = 311
food_1up      = 318
food_key      = 319
food_big_coin = 309

'used for sprite tile number and people-ID.
people_man = 0
people_rom
people_knight
people_cindy
people_cookie
people_wwiz
people_ghost
people_changev

'gender bit field. (knight isn't counted as male or female)
gender_male   = &b001
gender_female = &b010
gender_knight = &b100

AI_peaceful = 0 'mostly will not be used because of deadline...
AI_panic
AI_angry
AI_walking
AI_attacking
AI_shaking

'people's projectile attack ID
projectile_fireball = 0 ' far : ghost, wwiz
projectile_hadoken  = 1 ' far : cindy
projectile_slash    = 2 ' near : man, rom, knight
projectile_smash    = 2 ' near : cookie

channel_free = -1
channel_click
channel_whack
channel_punch
channel_ARRRG
channel_munch
channel_jump
channel_glass
channel_door

sfx_click = 0
sfx_whack
sfx_punch
sfx_ARRRG
sfx_munch
sfx_jump
sfx_glass
sfx_door

END ENUM

'--- type -------------------------------------------------
TYPE spark_
   used      AS INTEGER
   _type     AS INTEGER'sun. dia. star. puff
   x         AS INTEGER
   y         AS INTEGER
   _TIMER    AS INTEGER'lifetime
   spr_ptn   AS INTEGER' sprite graphic pattern
   spr_ptn_ctr AS INTEGER 'sprite animation counter
   spr_delay AS INTEGER'animation frame delay
END TYPE

TYPE ysort_
   id AS INTEGER
   used AS INTEGER
   y AS INTEGER
END TYPE

TYPE trail_
   x AS INTEGER
   y AS INTEGER
   face AS INTEGER
   ptn AS INTEGER
END TYPE


TYPE game_stat_

   mapx AS INTEGER 'current town position on world map
   mapy AS INTEGER

   timer_on AS INTEGER  'main timer switch. on. off.
   timer_display_on AS INTEGER  'main timer display on. off.
   old_timer AS INTEGER 'used in calculating seconds
   new_timer AS INTEGER 'used in calculating seconds
   game_time AS INTEGER 'stage timer
   timer_flash AS INTEGER

   max_time AS INTEGER

   'player related
   score   AS INTEGER
   hiscore AS INTEGER
   credit  AS INTEGER
   arena   AS INTEGER

   max_HP AS INTEGER 'max people hp per stage. will be increased as stage advances. harder to kill.

   helper AS INTEGER 'helper cursor that points hidden key. one time use.
   helper_y_ctr AS INTEGER
   rare_apple_count AS INTEGER 'break some more object before this food pops up
   rare_1up_count   AS INTEGER 'break some more object before this food pops up

   'town related
   wall_info    AS INTEGER 'wall info (bit) is where the door can be applied. (not water/cliff)
   locked_door  AS INTEGER 'locked door (bit) that will open when stage is cleared.
   door_u_state AS INTEGER
   door_r_state AS INTEGER
   door_d_state AS INTEGER
   door_l_state AS INTEGER
   door_z_state AS INTEGER

   attack_button AS INTEGER = 0 'first joypad button
   menu_button   AS INTEGER = 9 '

   max_object_in_town AS INTEGER '
   max_people_in_town AS INTEGER '
   max_people AS INTEGER 'number of people-bmp

   gameover_overlay AS INTEGER
   gameover_blink_ctr AS INTEGER
   gameover_ctr AS INTEGER 'when >100 then gameover screen ends and ask-continue pops up.
   beatgame AS integer
   cutscene_ctr AS INTEGER


   changev_talking         AS INTEGER 'talk script number. probably just 1
   changev_talking_ctr     AS INTEGER 'player will stand still and talk this much
   changev_talking_alpha AS INTEGER
   changev_hiding_ctr AS INTEGER
   base_x AS INTEGER
   base_y AS INTEGER
   steps AS INTEGER
   frame_ctr AS INTEGER 'special counter for calculating jumping animation frame
   arc_y AS INTEGER     'jumping arc delta y
   arc_delay AS INTEGER     'jumping arc delay

END TYPE

TYPE objects_
   used AS INTEGER 'just in case. general usedflag. if this is off, it will be out of main stuff loop.

   chara_type AS INTEGER 'player or human or object or particle(not supported yet)

   id AS INTEGER 'which person? or which object?
   state AS INTEGER
   hit_detect AS INTEGER 'ignore hit detection if needed.
   hp AS INTEGER  'full = 100
   def AS INTEGER 'defense. (slime attack - defense) = damage. if tough defense = unbeatable.

   'hp bar related. player, object, people use it.
   hp_alpha    AS INTEGER 'hp bar ALPHA level
   hp_timer    AS INTEGER 'hp bar display timer
   is_not_dead AS INTEGER 'dead or alive flag.  affect sprite, hit detect, ...etc.

   x        AS INTEGER
   y        AS INTEGER
   dy       AS INTEGER 'incase character tries jumping
   is_moved AS INTEGER 'this thing is moved. do animation later.
   action   AS INTEGER 'action... attack, absorb...etc???

   face         AS INTEGER 'facing direction
   spr_id       AS INTEGER 'sprite/tile pattern number
   anim_ptn     AS INTEGER
   anim_ptn_ctr AS INTEGER 'animation delay
   ctr AS INTEGER

   has_key AS INTEGER '

   'used only in people... maybe use union to combine with food property to save some memory.
   MP       AS INTEGER ' melt point. people will melt if MP reaches zero. (not Magic Point)
   mp_alpha AS INTEGER 'mp bar ALPHA level
   mp_timer AS INTEGER 'mp bar display timer
   gender AS INTEGER
   AI     AS INTEGER 'some AI
   walking_distance AS INTEGER


   'shake AS INTEGER 'shaking flag

   shake_timer AS INTEGER       'will shake this much when hit by punch
   shake_idx     AS INTEGER
   shake_idx_ctr AS INTEGER
   shake_x AS INTEGER
   shake_y AS INTEGER 'not used
   fired AS INTEGER 'people can fire just one projectile at a time.

   'attacking AS INTEGER 'attack flag
   attack_ctr AS INTEGER 'how long attack animation will take


   skull_timer AS INTEGER
   skull_alpha AS INTEGER

   'used only in food
   bounce_max_y AS INTEGER 'maximum bouncy
   bounce_y     AS INTEGER
   bounce_timer AS INTEGER

   'used only in projectile
   parent AS INTEGER       'who threw this thing. back-track then free people to attack again.

END TYPE

TYPE player_  'extra 'player only' info for player that's not included in chara/object property
   enter_direction  AS INTEGER 'which side the player will enter. enter_diretion may be better name.
   have_key        AS INTEGER

   control         AS INTEGER 'when punching, control is locked.

   talking         AS INTEGER 'talk script number. probably just 1
   talking_ctr     AS INTEGER 'player will stand still and talk this much
   talking_alpha AS INTEGER

   button_released AS INTEGER 'attack button released flag.
   button_hold     AS INTEGER 'attack button released flag.

   punch_x         AS INTEGER
   punch_y         AS INTEGER
   punch_direction AS INTEGER
   punch_state     AS INTEGER 'punch will wait a few frame then retract
   punch_ctr       AS INTEGER

   blink AS INTEGER 'blink flag
   blink_ctr AS INTEGER 'how fast player will blink
   blink_timer AS INTEGER 'how long player will blink

   ctr  AS INTEGER
   cut_in_counter AS INTEGER 'dramatic death cut-in effect counter.
   cut_in_layer AS INTEGER   '???

   zomg_counter AS INTEGER 'how long slime will be shocked on ending demo
END TYPE

TYPE medal_point_ 'somekind of achivement
   list AS STRING * 8
   number_of_medal AS INTEGER ' medal counter. at least 6 medal will unlock something.
   get_key         AS INTEGER ' easy
   kill_10_male    AS INTEGER ' easy
   kill_10_female  AS INTEGER ' easy
   kill_10_knight  AS INTEGER ' easy
   break_99_object AS INTEGER ' normal
   MiniRPG         AS INTEGER ' normal
   find_candy      AS INTEGER ' easy
   no_miss         AS INTEGER ' hard

   'supporting internal tracking variables.
   number_of_male_killed   AS INTEGER
   number_of_female_killed AS INTEGER
   number_of_knight_killed AS INTEGER
   number_of_object_broken AS INTEGER
   number_of_MiniRPG_towns AS INTEGER
   number_of_continue_used AS INTEGER

   message AS STRING
   message_alpha AS INTEGER 'translucency level of message window
   message_type  AS INTEGER 'which medal the player just achived?
   message_timer AS INTEGER 'message displaying time (1 message only. newer will replace old one)
   message_y_offset AS INTEGER 'message panel movement offset

END TYPE

TYPE t_people_
   people_name AS STRING * 12
   image AS fb.image PTR
   gender AS INTEGER
END TYPE



DECLARE SUB ASK_QUIT(BYREF result AS INTEGER)
DECLARE SUB ASK_CONTINUE(BYREF result AS INTEGER)

DECLARE SUB TITLE(BYREF result AS INTEGER)
DECLARE SUB CUT_SCENE(n AS INTEGER=0)
DECLARE SUB DISPLAY_STATUS()
DECLARE SUB WARNING()
DECLARE SUB option_menu()


'---< Global variables >-----------------------------------------------------------------

'global variables
DIM SHARED AS game_stat_ stat
DIM SHARED AS player_ slime
DIM SHARED AS spark_ spark(max_spark_limit)

DIM SHARED AS objects_ chara(max_every_stuff_limit) 'every stuff that uses Ysort for displaying.
DIM SHARED AS ysort_   ysort(max_every_stuff_limit) 'y position list for Y-sorting.

DIM SHARED AS fb.image PTR t_tile, t_player, t_minimap, t_shadow, t_trail, t_medal_panel, t_spark
DIM SHARED AS fb.image PTR t_number, t_flash_number, t_status, t_projectile, t_quit, t_gameover
DIM SHARED AS fb.image PTR t_menu_big, t_menu_small, t_eye, t_skull, t_continue, t_forest
DIM SHARED AS fb.image PTR t_c_chv, t_c_slime,  t_balloon

REDIM SHARED AS t_people_ t_people(0) 'people tiles

DIM SHARED AS INTEGER town_map(20, 15), town_walkable_map(20, 15), overlay_map(20, 15)

DIM SHARED AS trail_ trail(max_trail_limit)
DIM SHARED AS INTEGER trail_idx 'trail ring index

DIM SHARED AS medal_point_ medal 'somekind of achivement

'---< function/sub prototype and stuff >--------------------------------------------------------

SUB PRINT_ (s AS STRING)
   DIM AS INTEGER DEBUG = FREEFILE
   OPEN CONS FOR OUTPUT AS #debug 'debug message log
   ? #debug, s
   CLOSE #debug
END SUB

SUB CLEANUP DESTRUCTOR
   'this will reduce some typing. I'm lazy.
   #DEFINE remove(blahblah) IF ( blahblah ) <> 0 THEN IMAGEDESTROY( blahblah )

   PRINT_ "-Clean up"
   remove ( t_tile )
   remove ( t_player )
   remove ( t_minimap )
   remove ( t_shadow )
   remove ( t_trail )
   remove ( t_medal_panel )
   remove ( t_spark )
   remove ( t_number )
   remove ( t_flash_number )
   remove ( t_status )
   remove ( t_projectile )
   remove ( t_quit )
   remove ( t_gameover )
   remove ( t_menu_big )
   remove ( t_menu_small )
   remove ( t_eye )
   remove ( t_skull )
   remove ( t_continue )
   remove ( t_forest )
   ' remove ( t_walk )
   remove ( t_c_chv )
   remove ( t_c_slime )
   'remove ( t_surprise )
   remove ( t_balloon )
END SUB

FUNCTION BMPLOAD(BMP_name AS STRING) AS fb.image PTR

   DIM AS INTEGER ff = FREEFILE
   DIM AS INTEGER bmp_width, bmp_height
   DIM AS fb.image PTR bmp_tile

   'get BMP width and height
   OPEN BMP_name FOR BINARY AS #ff
   GET #ff, 19, bmp_width
   GET #ff, 23, bmp_height
   CLOSE #ff
   PRINT_ " Loading tile '" & BMP_name & "'. size (" & bmp_width & " x " & bmp_height & ")"

   'load bmp file
   bmp_tile = IMAGECREATE(bmp_width, bmp_height) 'create buffer then load into it.
   BLOAD BMP_name, bmp_tile

   RETURN bmp_tile

END FUNCTION

SUB RESET_CHARA()
   'turn off various stuff in objects
   FOR i AS INTEGER = 1 TO max_every_stuff_limit
      chara(i).used = FALSE
      chara(i).has_key = FALSE
      chara(i).y = 0
      chara(i).chara_type = 0
      chara(i).state = 0
      chara(i).hp_timer = 0
      chara(i).MP = 0
      chara(i).mp_timer = 0
      chara(i).fired = FALSE
   NEXT

   'player too
   chara(0).state = 0
   chara(0).hp_timer = 0
   chara(0).fired = FALSE

   WITH slime
      .blink_timer =0
      .blink_ctr = 0
      .blink = false
   END WITH

END SUB

SUB SET_MEDAL_MESSAGE (n AS INTEGER)

   medal.message_type = n
   medal.message_timer = 200 'message will be displayed this long...
   medal.message_alpha = 160

   SELECT CASE n
      CASE medal_get_key         : medal.message = "Got first key"
      CASE medal_kill_10_male    : medal.message = "Killed 10 males"
      CASE medal_kill_10_female  : medal.message = "Killed 10 females"
      CASE medal_kill_10_knight  : medal.message = "Killed 10 knights"
      CASE medal_MiniRPG         : medal.message = "MiniRPG towns tour"
      CASE medal_find_candy      : medal.message = "find Candy"
      CASE medal_break_99_object : medal.message = "Break 99 objects"
      CASE medal_no_miss         : medal.message = "No MISS clear"
   END SELECT

   'add some space at front to align strings...
   medal.message = STRING((18 - LEN(medal.message)) \ 2, " ") & medal.message
   medal.message_y_offset = 0

END SUB

SUB DISPLAY_MEDAL_MESSAGE ()

   #DEFINE medal_X 240
   #DEFINE medal_Y 220

   DIM AS INTEGER msg_length, message_y_move = 0

   WITH medal

      'check if it is time to end message displaying
      .message_timer -= 1
      IF .message_timer < 0 THEN .message_type = medal_none:.message_timer = 0

      IF .message_timer < 40 THEN .message_alpha -= 4: .message_y_offset -= 1 'move message panel upward
      IF .message_alpha <  0 THEN .message_alpha = 0

      'if nothing to display, skip!
      IF  medal.message_type <> medal_none THEN

         'put medal panel.
         PUT (medal_x, medal_y+medal.message_y_offset), t_medal_panel, ALPHA, medal.message_alpha

         'then add some message on it.
         msg_length = LEN(LTRIM(medal.message))
         DRAW STRING (medal_X+38+4,  medal_Y+2+5+medal.message_y_offset), "< 1 medal point >" ,RGBA(255,255,255,medal.message_alpha+20)
         DRAW STRING (medal_X+38+(msg_length AND 1)*4, medal_Y+12+10+medal.message_y_offset), medal.message, RGBA(255,255,255,medal.message_alpha)

      END IF
   END WITH

END SUB


SUB LOAD_TOWN(gx AS INTEGER = 0, gy AS INTEGER = 3)

   stat.timer_display_on = TRUE
   IF gx=0 AND gy=3 THEN stat.timer_display_on = FALSE
   IF gx=5 AND gy=0 THEN chara(0).hp = 100:chara(0).hp_timer = 0

   'stat.game_time = stat.max_time  'time limit for each stage. maybe increase some as stage dvances...
   stat.gameover_ctr = 0
   stat.gameover_blink_ctr = 0
   stat.changev_hiding_ctr = 0
   stat.timer_on = FALSE

   #DEFINE walkable_tile 63

   DIM AS INTEGER random_key_position, key_is_hidden = FALSE
   DIM AS INTEGER f = FREEFILE', loading_limit
   DIM AS STRING dummy

   RESET_CHARA()

   'load town based on minimap grid position
   PRINT_ "-Loading town."
   PRINT_ " town ID:" & gx & "-" & gy

   OPEN "town\town" & gx & gy & ".txt" FOR INPUT AS #f

   'read town tile-map data and store into town_map array
   FOR i AS INTEGER = 0 TO 14
      INPUT #f, town_map( 0, i), town_map( 1, i), town_map( 2, i), town_map( 3, i), town_map( 4, i),_
      town_map( 5, i), town_map( 6, i), town_map( 7, i), town_map( 8, i), town_map( 9, i),_
      town_map(10, i), town_map(11, i), town_map(12, i), town_map(13, i), town_map(14, i),_
      town_map(15, i), town_map(16, i), town_map(17, i), town_map(18, i), town_map(19, i)
   NEXT

   PRINT_ " making walkable map"
   'town tile map is loaded.
   'scan all tile and make walkable map. using tile# <= 64
   FOR j AS INTEGER = 0 TO 14
      FOR i AS INTEGER = 0 TO 19
         town_walkable_map(i, j) = IIF((town_map(i, j) <= walkable_tile), walkable_grid , blocked_grid) '-1=walkable
      NEXT
   NEXT

   'also, add overlay roof panel for some roofs
   PRINT_ " making roof overlay map"
   FOR j AS INTEGER = 0 TO 14
      FOR i AS INTEGER = 0 TO 19
         IF town_map(i, j) >= 32 AND town_map(i, j) <= 63 THEN
            overlay_map(i, j) = town_map(i, j) + 160 + 64 -(32)'(expanded 64 more tiles)
         ELSE
            overlay_map(i, j) = 0 'reset just in case
         END IF
      NEXT
   NEXT

   'load wall information. passanle road or not. in bit field form.
   LINE INPUT #f, dummy
   stat.wall_info = convertSTR(dummy, 20)

   PRINT_ " valid wall (bit): " & stat.wall_info

   CLOSE #f

   '---------loading objects -------------------------------------------------
   PRINT_ "Loading objects"
   'then this time, open obj list tile and init objs.
   f = FREEFILE

   OPEN "town\obj_" & gx & gy & ".txt" FOR INPUT AS #f

   'how many objects are in the town. (maybe add limit like 64.)
   LINE INPUT #f, dummy
   stat.max_object_in_town = convertSTR(dummy, 20)
   PRINT_ " max number of object on file: " & stat.max_object_in_town

   IF stat.max_object_in_town = 0 THEN
      PRINT_ "object not found on file"
      PRINT_ "skip object loading"
   ELSE
      PRINT_ " max number of object on file: " & stat.max_object_in_town

      'just in case, limit the maximum to 64 (or other preset value)
      IF stat.max_object_in_town > max_object_limit THEN
         stat.max_object_in_town = max_object_limit - 1
         PRINT_ " loading limit reached. will read only "& (max_object_limit) &" objects"
      END IF

      PRINT_ " object will be loaded from #" & object_min_bound & " to #" & (object_min_bound + stat.max_object_in_town-1)

      'then load individual objects.
      FOR i AS INTEGER = object_min_bound TO object_min_bound + (stat.max_object_in_town-1)
         WITH chara(i)

            .chara_type = object_type
            .used = TRUE

            INPUT #f, dummy,  .x,  .y 'read position as grid position
            'load more detailed info too such as 'indestructable' later

            SELECT CASE LCASE(dummy)
               CASE "tree"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : tree"
                  .spr_id = tree_object
                  .def = 100 - ( 16)
                  town_walkable_map(.x, .y) = non_walkable_grid *01
               CASE "barrel"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : barrel"
                  .spr_id = barrel_object
                  .def = 100 - ( 30 )
                  town_walkable_map(.x, .y) = non_walkable_grid*01
               CASE "sign"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : sign"
                  .spr_id = sign_object
                  .def = 100 - ( 40 )
                  town_walkable_map(.x, .y) = non_walkable_grid*01
               CASE "well"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : well"
                  .spr_id = well_object
                  .def = 100 - ( 10)
                  town_walkable_map(.x, .y) = non_walkable_grid*01
               CASE "cross"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : cross"
                  .spr_id = cross_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid
               CASE "tombstone"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : tomestone"
                  .spr_id = tombstone_object
                  .def = 100 - ( 13 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "mailbox"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : mailbox"
                  .spr_id = mailbox_object
                  .def = 100 - ( 22 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "jar"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : jar"
                  .spr_id = jar_object
                  .def = 100 - ( 38 )
                  town_walkable_map(.x, .y) = non_walkable_grid*01

               CASE "rock"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : rock"
                  .spr_id = rock_object
                  .def = 100 - ( 15 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "door"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : door"
                  .spr_id = door_object
                  .def = 100 - ( 34 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "hole_big", "hole1"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : hole_big"
                  .spr_id = hole_big_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "hole_small", "hole2"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : hole_small"
                  .spr_id = hole_small_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "hole_window", "hole3"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : hole_window"
                  .spr_id = hole_window_object
                  .def = 100 - ( 100 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "tri_roof_l"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : tri_roof_l"
                  .spr_id = tri_roof_l_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "tri_roof_r"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : tri_roof_r"
                  .spr_id = tri_roof_r_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "rom_window"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : rom_window"
                  .spr_id = rom_window_object
                  .def = 100 - ( 100 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "rom_door"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : rom_door"
                  .spr_id = rom_door_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "cookie_window"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : cookie_window"
                  .spr_id = cookie_window_object
                  .def = 100 - ( 100 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "cookie_wall"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : cookie_wall"
                  .spr_id = cookie_wall_object
                  .def = 100 - ( 18 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "cookie_door"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : cookie_door"
                  .spr_id = cookie_door_object
                  .def = 100 - ( 6 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "castle_door_l"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : castle_door_l"
                  .spr_id = castle_door_l_object
                  .def = 100 - ( 13 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "castle_door_r"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : castle_door_r"
                  .spr_id = castle_door_r_object
                  .def = 100 - ( 13 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE "castle_wall"
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : castle_wall"
                  .spr_id = castle_wall_object
                  .def = 100 - ( 13 )
                  town_walkable_map(.x, .y) = non_walkable_grid

               CASE ELSE
                  PRINT_ "  # " & i & ": object on grid(" & .x & ", " & .y & ") : invalid"
                  .spr_id = invalid_object
                  .def = 100
                  town_walkable_map(.x, .y) = non_walkable_grid

            END SELECT

            'calculate grid position as actual screen position
            .x *= 32
            .y *= 32
            .hp = 100
            .is_not_dead = TRUE
            IF .def>100 THEN .def=100
            IF .def<0 THEN .def=0

         END WITH
      NEXT
   END IF

   CLOSE #f

   'load people too
   '---------loading people -------------------------------------------------
   PRINT_ "Loading people"
   'then this time, open people list tile and init objs.
   f = FREEFILE

   OPEN "town\people_" & gx & gy & ".txt" FOR INPUT AS #f

   'read timelimit for the town.
   LINE INPUT #f, dummy
   stat.game_time = convertSTR(dummy, 20)

   'how many people are in the town.
   LINE INPUT #f, dummy
   stat.max_people_in_town = convertSTR(dummy, 20)

   IF stat.max_people_in_town = 0 THEN
      PRINT_ "people not found on file"
      PRINT_ "skip people loading"
   ELSE
      PRINT_ " max number of people on file: " & stat.max_people_in_town

      'just in case, limit the maximum to preset value.
      IF stat.max_people_in_town > max_people_limit THEN
         stat.max_people_in_town = max_people_limit - 1
         PRINT_ " loading limit reached. will read only "& (max_people_limit) &" people"
      END IF

      PRINT_ " people will be loaded from #" & people_min_bound & " to #" & (people_min_bound + stat.max_people_in_town-1)

      'then load individual people.
      FOR i AS INTEGER = people_min_bound TO people_min_bound + (stat.max_people_in_town-1)
         WITH chara(i)

            .chara_type = people_type
            INPUT #f, dummy,  .x,  .y 'read position and other important stuff


            SELECT CASE LCASE(dummy)
               '"man", "rom",
               CASE "man"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_man
               CASE "rom"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_rom
               CASE "knight"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_knight
               CASE "cindy"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_cindy
               CASE "cookie"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_cookie
               CASE "wwiz"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_wwiz
               CASE ELSE '"ghost"
                  PRINT_ "  # " & i & ": " & dummy & " at (" & .x & ", " & .y & ")"
                  .id = people_ghost
            END SELECT

            'calculate grid position as actual screen position
            .used = TRUE
            .spr_id = .id
            .gender = t_people(.id).gender
            .x *= 32 'convert grid position to actual screen position.
            .y *= 32
            .hp = stat.max_HP 'people will have this much HP on this stage.
            .MP = 500 'melt point. not magic point.
            .action = AI_shaking
            .def = 100 - ( 55)  '55

            'IF .def>150 THEN .def=100
            IF .def<0 THEN .def=0

         END WITH
      NEXT

   END IF

   CLOSE #f

   'after loading object and people... it's time to hid the key.
   'for zoo stage, key is hardcoded starting from 3rd object to last one. not the first barrel or well.
   IF gx= 0 AND gy=3 THEN
      'starting from 3rd object. select randomly
      random_key_position = INT(RND*(stat.max_object_in_town-2))
      chara(object_min_bound + 2 + random_key_position ).has_key = TRUE
      PRINT_ "zoo key is hidden in some object"

   ELSEIF gx<>5 OR gy<>0 THEN

      key_is_hidden = FALSE

      'decide object or people then hide within the group.
      IF RND>.5 THEN 'hide in people
         DO
            random_key_position = INT(RND*(stat.max_people_in_town))

            key_is_hidden = TRUE
            chara(people_min_bound +  random_key_position ).has_key = TRUE
            PRINT_ "key is hidden"' in some people"
         LOOP UNTIL key_is_hidden

      ELSE 'hide inside of objects
         DO
            random_key_position = INT(RND*(stat.max_object_in_town))

            'check if it is valid object for hiding
            IF chara(object_min_bound +  random_key_position ).spr_id < door_object THEN
               key_is_hidden = TRUE
               chara(object_min_bound +  random_key_position ).has_key = TRUE
               PRINT_ "key is hidden"' in some object"
            ELSE
               'PRINT_ "trying to hide key in wall... retrying..."
            END IF
         LOOP UNTIL key_is_hidden

      END IF

   END IF  'end of key hiding process

   '---< medal (town tour) processing >---
   IF gx=3 AND gy= 0 THEN medal.number_of_MiniRPG_towns OR= &h01 'check if this is minirpg3 town
   IF gx=4 AND gy= 0 THEN medal.number_of_MiniRPG_towns OR= &h02 'check if this is minirpg3 town
   'if minirpg medal is available, get! (just once in gameplay)
   IF NOT medal.MiniRPG THEN
      IF (medal.number_of_MiniRPG_towns AND &h3) = &h3 THEN
         medal.MiniRPG = TRUE
         MID(medal.list, 3) = "/"
         medal.number_of_medal += 1
         SET_MEDAL_MESSAGE (medal_MiniRPG)
      END IF
   END IF 'end of medal processing

   'last stage reached. check for no miss.
   IF gx=5 AND gy= 0 THEN
      IF medal.number_of_continue_used = 0 THEN
         IF NOT medal.no_miss THEN
            medal.no_miss = TRUE
            MID(medal.list, 1) = "/"
            medal.number_of_medal += 1
            SET_MEDAL_MESSAGE (medal_no_miss)
         END IF 'end of medal processing
      END IF

   END IF

   chara(changev_slot).used = TRUE
   chara(changev_slot).chara_type = changev_type
   chara(changev_slot).state = chv_state_outside
   chara(changev_slot).spr_id = 1
   chara(changev_slot).x = -32
   chara(changev_slot).y = -32
   chara(changev_slot).dy = -32
   chara(changev_slot).spr_id = 7

END SUB

SUB SAVE_HISCORE() 'reused routine from Final Invader DX

   PRINT_ "-Saving hiscore : " & stat.hiscore

   OPEN "hiscore.txt" FOR OUTPUT AS #1
   PRINT #1, "hi-score"
   PRINT #1, stat.hiscore
   CLOSE #1
END SUB

SUB LOAD_HISCORE() 'reused routine from Final Invader DX

   DIM AS INTEGER hiscore_filesize
   DIM AS STRING dummy_string

   PRINT_ "-Loading hiscore"

   'check if there is hi-score file
   OPEN "hiscore.txt" FOR APPEND AS #1
   hiscore_filesize = LOF(1)
   CLOSE #1

   'if not found then initialize with 1000 pts
   IF hiscore_filesize = 0 THEN
      PRINT_ " hiscore file not found"
      stat.hiscore = 1000
      PRINT_ " set default : " & stat.hiscore

      SAVE_HISCORE()
   ELSE 'if found then load it from file
      OPEN "hiscore.txt" FOR INPUT AS #1
      INPUT #1, dummy_string
      INPUT #1, stat.hiscore
      CLOSE #1
      PRINT_ " hiscore loaded : " & stat.hiscore
   END IF
END SUB

SUB LOAD_NUMBER_FONT(BYREF imgptr AS fb.IMAGE PTR, filename AS STRING)
   'hardcoded font bitmap for draw string
   DIM AS UBYTE PTR p

   #DEFINE fixed_width 11

   imgptr = BMPLOAD(filename)

   'point 'p' to first pixel area
   IMAGEINFO( imgptr, , , , , p )

   'write manually
   p[0] = 0        'header
   p[1] = ASC("-") 'first ascii code
   p[2] = ASC("9") 'last ascii code

   'then write width of each letters.
   FOR i AS INTEGER = 0 TO   (p[2] - p[1])
      p [3 + i] = fixed_width 'fixed width for each letters
   NEXT

END SUB

SUB INIT_MAIN()
   'load hiscore
   'load tiles
   'max stage

   PRINT_ "- Initialize main"

   DIM AS INTEGER f '= FREEFILE
   DIM AS STRING dummy

   'load graphics (t_ prefix = tile/image)
   t_tile = BMPLOAD("gfx\all_tiles.bmp")         'for background
   t_minimap = BMPLOAD("gfx\minimap.bmp")        'for minimap
   t_player = BMPLOAD("gfx\player.bmp")          'player
   t_trail = BMPLOAD("gfx\slime_trail.bmp")      'slime trail
   t_medal_panel = BMPLOAD("gfx\medal_panel.bmp")'medal panel
   t_spark = BMPLOAD("gfx\spark.bmp")            'spark and dia particle
   t_status = BMPLOAD("gfx\status.bmp")          'status info
   t_projectile = BMPLOAD("gfx\projectile.bmp")  'projectile
   t_quit = BMPLOAD("gfx\quit.bmp")              'quit menu
   't_spin = BMPLOAD("gfx\chv_spin.bmp")          'spinning ChangeV kick
   t_gameover = BMPLOAD("gfx\gameover.bmp")      'big game over
   t_menu_big = BMPLOAD("gfx\menu_big.bmp")    'title menu font
   t_menu_small = BMPLOAD("gfx\menu_small.bmp")'title menu font
   t_eye = BMPLOAD("gfx\eye.bmp")              'title menu eye
   t_skull = BMPLOAD("gfx\bigskull.bmp")        'title menu skull
   t_continue = BMPLOAD("gfx\continue.bmp")     'continue
   t_forest = BMPLOAD("gfx\forest.bmp")         'scrollable forest
   ' t_walk = BMPLOAD("gfx\walk.bmp")
   t_c_chv = BMPLOAD("gfx\cont_changev.bmp")         'scrollable forest
   t_c_slime = BMPLOAD("gfx\cont_slime.bmp")         'scrollable forest
   't_surprise = BMPLOAD("gfx\surprise.bmp")         'found you from well

   t_balloon = BMPLOAD("gfx\balloon.bmp")          'word-balloon

   LOAD_NUMBER_FONT(t_number, "gfx\number.bmp") 'number-font for draw string. need to modify header.
   LOAD_NUMBER_FONT(t_flash_number, "gfx\flash_number.bmp") 'number-font for draw string. need to modify header.

   t_shadow = IMAGECREATE (640, 480) 'create shadow/trail buffer as big as whole screen

   'load people graphics.
   f = FREEFILE
   OPEN "gfx\people_list.txt" FOR INPUT AS #f

   'read max number of people-bmp
   LINE INPUT #f, dummy: stat.max_people = convertSTR(dummy, 20)

   'resize the people array (that holds image buffer and gender, name)
   REDIM AS t_people_ t_people(stat.max_people)

   LINE INPUT #f, dummy 'read dummy line
   FOR i AS INTEGER = 0 TO (stat.max_people-1)
      WITH t_people(i)

         'load people's name and gender. then load bmp into image buffers
         INPUT #f, .people_name, .gender
         .image = BMPLOAD( "gfx\" + .people_name + ".bmp")

      END WITH
   NEXT
   CLOSE #f

   'loading config. probably will not used.
   f = FREEFILE
   OPEN "town\stuff.txt" FOR INPUT AS #f
   IF NOT EOF(f) THEN
      LINE INPUT #f, dummy
      IF dummy = "config_data" THEN stat.arena = TRUE
      PRINT_ "-" & dummy & " found"
   END IF

   CLOSE #f

   'load hiscore
   LOAD_HISCORE()

END SUB

SUB PUT_TILE(x AS INTEGER, y AS INTEGER, n AS INTEGER = 0)
   DIM AS INTEGER piecex = (n AND &h07) SHL 5
   DIM AS INTEGER piecey = (n SHR 3) SHL 5
   PUT(x,y), t_tile, (piecex, piecey)-(piecex + 31, piecey + 31), PSET
END SUB

SUB PUT_OVERLAY(x AS INTEGER, y AS INTEGER, n AS INTEGER = 0, alpha_level AS INTEGER = 255)
   DIM AS INTEGER piecex = (n AND &h07) SHL 5
   DIM AS INTEGER piecey = (n SHR 3) SHL 5
   IF alpha_level = 255 THEN
      PUT(x,y), t_tile, (piecex, piecey)-(piecex + 31, piecey + 31), TRANS
   ELSE
      PUT(x,y), t_tile, (piecex, piecey)-(piecex + 31, piecey + 31), ALPHA, alpha_level
   END IF

END SUB


SUB PUT_PLAYER(x AS INTEGER, y AS INTEGER, direction AS INTEGER, ptn AS INTEGER, img AS fb.image PTR, alpha_level AS INTEGER = 150)
   'PUT (x-2, y- 10), img, (1 + direction * 37, 1 + ptn * 37)-(1 + direction * 37 + 35, 1 + ptn * 37 + 35), ALPHA, 150
   PUT (x-6, y-10), img, (1 + direction * 45, 1 + ptn * 39)-(1 + direction * 45 + 43, 1 + ptn * 39 + 37), ALPHA, alpha_level
END SUB

SUB PUT_PEOPLE(x AS INTEGER, y AS INTEGER, direction AS INTEGER, ptn AS INTEGER, img AS fb.image PTR)
   PUT (x-6, y-10), img, (1 + direction * 45, 1 + ptn * 39)-(1 + direction * 45 + 43, 1 + ptn * 39 + 37), TRANS
END SUB

SUB PUT_SHADOW(x AS INTEGER, y AS INTEGER, direction AS INTEGER, ptn AS INTEGER, img AS fb.image PTR)
   PUT t_shadow,(x, y), img, (1 + direction * 37, 1 + ptn * 37)-(1 + direction * 37 + 35, 1 + ptn * 37 + 35), TRANS
END SUB

SUB PUT_MINIMAP(GX AS INTEGER=0, GY AS INTEGER=3)

   'minimap position
   #DEFINE XX (640 - t_minimap->WIDTH - 2)
   #DEFINE YY (0+2)

   'gx,gy is marker/room
   PUT (xx, yy), t_minimap,(0,slime.have_key*-25)-(57,slime.have_key*-25+25), PSET
   LINE(xx + gx * 6 + 3+17, yy + gy * 4 + 8)-(xx + gx * 6 + 7+17, yy + gy * 4 + 10), &hffffff00, bf

END SUB


SUB LOGO()

   CLS

   LOCATE 5,5
   PRINT "L O G O"
   SLEEP 1000

END SUB

SUB OPEN_DOOR(n AS INTEGER = &h1f)

   'setup the walkable map and door state too

   IF (stat.wall_info AND 1) = 0 THEN
      IF (n AND top_door) THEN 'lock top door
         stat.door_u_state = door_opened
         town_walkable_map( 8, 0) = opened_door
         town_walkable_map( 9, 0) = opened_door
         town_walkable_map(10, 0) = opened_door
         town_walkable_map(11, 0) = opened_door
         town_walkable_map( 8, 1) = opened_door
         town_walkable_map( 9, 1) = opened_door
         town_walkable_map(10, 1) = opened_door
         town_walkable_map(11, 1) = opened_door
      END IF
   END IF

   IF (stat.wall_info AND 2) = 0 THEN
      IF (n AND right_door) THEN 'lock right door
         stat.door_r_state = door_opened
         town_walkable_map(19, 6) = opened_door
         town_walkable_map(19, 7) = opened_door
         town_walkable_map(19, 8) = opened_door
      END IF
   END IF

   IF (stat.wall_info AND 4) = 0 THEN
      IF (n AND bottom_door) THEN 'lock bottom door
         stat.door_d_state = door_opened
         town_walkable_map( 8, 14) = opened_door
         town_walkable_map( 9, 14) = opened_door
         town_walkable_map(10, 14) = opened_door
         town_walkable_map(11, 14) = opened_door
      END IF
   END IF

   IF (stat.wall_info AND 8) = 0 THEN
      IF (n AND left_door) THEN 'lock left door
         stat.door_l_state = door_opened
         town_walkable_map(0, 6) = opened_door
         town_walkable_map(0, 7) = opened_door
         town_walkable_map(0, 8) = opened_door
      END IF
   END IF

   IF (stat.wall_info AND 16) = 0 THEN
      IF (n AND zoo_door) THEN 'lock zoo door
         stat.door_z_state = door_opened
         town_walkable_map(19, 13) = opened_door
      END IF
   END IF

END SUB

SUB LOCK_DOOR(n AS INTEGER = &h1f)

   'setup the walkable map and door state too
   IF (stat.wall_info AND 1) = 0 THEN
      IF (n AND top_door) THEN 'lock top door
         stat.door_u_state = door_locked
         town_walkable_map( 8, 0) = locked_door
         town_walkable_map( 9, 0) = locked_door
         town_walkable_map(10, 0) = locked_door
         town_walkable_map(11, 0) = locked_door
         town_walkable_map( 8, 1) = locked_door
         town_walkable_map( 9, 1) = locked_door
         town_walkable_map(10, 1) = locked_door
         town_walkable_map(11, 1) = locked_door
      END IF
   END IF

   IF (stat.wall_info AND 2) = 0 THEN
      IF (n AND right_door) THEN 'lock right door
         stat.door_r_state = door_locked
         town_walkable_map(19, 5) = blocked_door
         town_walkable_map(19, 6) = locked_door
         town_walkable_map(19, 7) = locked_door
         town_walkable_map(19, 8) = locked_door
      END IF
   END IF

   IF (stat.wall_info AND 4) = 0 THEN
      IF (n AND bottom_door) THEN 'lock bottom door
         stat.door_d_state = door_locked
         town_walkable_map( 8, 14) = locked_door
         town_walkable_map( 9, 14) = locked_door
         town_walkable_map(10, 14) = locked_door
         town_walkable_map(11, 14) = locked_door
      END IF
   END IF

   IF (stat.wall_info AND 8) = 0 THEN
      IF (n AND left_door) THEN 'lock left door
         stat.door_l_state = door_locked
         town_walkable_map(0, 5) = blocked_door
         town_walkable_map(0, 6) = locked_door
         town_walkable_map(0, 7) = locked_door
         town_walkable_map(0, 8) = locked_door
      END IF
   END IF

   IF (stat.wall_info AND 16) = 0 THEN
      IF (n AND zoo_door) THEN 'lock zoo door
         stat.door_z_state = door_locked
         town_walkable_map(19, 13) = locked_door
      END IF
   END IF

END SUB

SUB BLOCK_DOOR(n AS INTEGER = &h10)

   'setup the walkable map and door state too
   IF (stat.wall_info AND 1) = 0 THEN
      IF (n AND top_door) THEN 'lock top door
         stat.door_u_state = door_blocked
         town_walkable_map( 8, 0) = blocked_door
         town_walkable_map( 9, 0) = blocked_door
         town_walkable_map(10, 0) = blocked_door
         town_walkable_map(11, 0) = blocked_door
         town_walkable_map( 8, 1) = blocked_door
         town_walkable_map( 9, 1) = blocked_door
         town_walkable_map(10, 1) = blocked_door
         town_walkable_map(11, 1) = blocked_door
      END IF
   END IF

   IF (stat.wall_info AND 2) = 0 THEN
      IF (n AND right_door) THEN 'block right door
         stat.door_r_state = door_blocked
         town_walkable_map(19, 6) = blocked_door
         town_walkable_map(19, 7) = blocked_door
         town_walkable_map(19, 8) = blocked_door
      END IF
   END IF

   IF (stat.wall_info AND 4) = 0 THEN
      IF (n AND bottom_door) THEN 'block bottom door
         stat.door_d_state = door_blocked
         town_walkable_map( 8, 14) = blocked_door
         town_walkable_map( 9, 14) = blocked_door
         town_walkable_map(10, 14) = blocked_door
         town_walkable_map(11, 14) = blocked_door
      END IF
   END IF

   IF (stat.wall_info AND 8) = 0 THEN
      IF (n AND left_door) THEN 'block left door
         stat.door_l_state = door_blocked
         town_walkable_map(0, 6) = blocked_door
         town_walkable_map(0, 7) = blocked_door
         town_walkable_map(0, 8) = blocked_door
      END IF
   END IF

   IF (stat.wall_info AND 16) = 0 THEN
      IF (n AND zoo_door) THEN 'block zoo door
         stat.door_z_state = door_blocked
         town_walkable_map(19,13) = blocked_door
      END IF
   END IF

END SUB

SUB GO_AROUND(BYREF obj AS objects_, steps AS INTEGER = 0)

   #DEFINE walkable_tile 63

   DIM AS INTEGER grid_x, grid_y, grid_x_offset, grid_y_offset

   WITH obj

      grid_x        = .x \ 32
      grid_y        = .y \ 32
      grid_x_offset = .x MOD 32
      grid_y_offset = .y MOD 32

      'based on face direction, go around obstacle.
      'if need to change diredtion, face that way too.
      SELECT CASE .face

         CASE facing_right
            IF grid_x_offset = 0 THEN 'hit right wall

               IF grid_y_offset <=16 THEN
                  IF town_walkable_map(grid_x + 1, grid_y    ) = 0 THEN
                     .y -= steps
                     .face = facing_up
                  END IF
               ELSE
                  IF town_walkable_map(grid_x + 1, grid_y + 1) = 0 THEN
                     .y += steps
                     .face = facing_down
                  END IF
               END IF
            END IF

         CASE facing_left
            IF grid_x_offset = 0 THEN 'hit left wall
               IF grid_y_offset <=16 THEN
                  IF town_walkable_map(grid_x - 1, grid_y    ) = 0  THEN
                     .y -= steps
                     .face = facing_up
                  END IF
               ELSE
                  IF town_walkable_map(grid_x - 1, grid_y + 1)  = 0 THEN
                     .y += steps
                     .face = facing_down
                  END IF
               END IF
            END IF

         CASE facing_up
            IF grid_y_offset = 0 THEN 'hit left wall
               IF grid_x_offset <=16 THEN
                  IF town_walkable_map(grid_x    , grid_y - 1)  = 0 THEN
                     .x -= steps
                     .face = facing_left
                  END IF
               ELSE
                  IF town_walkable_map(grid_x + 1, grid_y - 1)  = 0 THEN
                     .x += steps
                     .face = facing_right
                  END IF
               END IF
            END IF

         CASE facing_down
            IF grid_y_offset = 0 THEN 'hit left wall
               IF grid_x_offset <=16 THEN
                  IF town_walkable_map(grid_x    , grid_y + 1)  = 0 THEN
                     .x -= steps
                     .face = facing_left
                  END IF
               ELSE
                  IF town_walkable_map(grid_x + 1, grid_y + 1)  = 0 THEN
                     .x += steps
                     .face = facing_right
                  END IF
               END IF
            END IF
      END SELECT
   END WITH
END SUB

SUB INIT_NEWGAME(game_mode AS INTEGER)

   '
   'support arena mode. nope. no time to add. canceled.

   PRINT_ "-Initialize new game-"

   'score reset
   stat.score = 0
   PRINT_ " score reset"

   'credit set
   stat.credit = 2
   PRINT_ " set credit to " & stat.credit

   'initialize/load stuff that only initialize each time in NEW game.
   chara(0).used = TRUE 'activate player, so main loop will process it. probably not used...

   '- all medal and medal helper reset -
   medal.list = "........" 'used on status display using draw string.(lazy way)

   medal.number_of_medal = 0
   medal.get_key         = FALSE
   medal.kill_10_male     = FALSE
   medal.kill_10_female   = FALSE
   medal.kill_10_knight   = FALSE
   medal.find_candy       = FALSE
   medal.MiniRPG         = FALSE
   medal.break_99_object = FALSE
   medal.no_miss         = FALSE

   'supporting internal tracking variables.
   medal.number_of_male_killed   = 0'+8
   medal.number_of_female_killed = 0'+8
   medal.number_of_knight_killed = 0'+8
   medal.number_of_object_broken = 0'+48
   medal.number_of_MiniRPG_towns = &h0
   medal.number_of_continue_used = 0

   stat.helper = TRUE 'this will show where the key is hiding. will be off after using the helper.

   'rare food appear point reset.
   stat.rare_apple_count = 0
   stat.rare_1up_count   = 0

   stat.gameover_overlay = FALSE
   stat.gameover_blink_ctr = 0
   stat.gameover_ctr = 0

   stat.beatgame = false

   stat.max_HP = 150 ' people's max hp

   chara(0).hp = 100 ' player starts with full HP

   'hp related stuff reset too. hpbar
   slime.ctr = 0 'set dying animation counter reset ' unused? remove.
   slime.cut_in_counter = 0
   slime.cut_in_layer = FALSE

   RESET_CHARA()

END SUB


FUNCTION WALKABLE OVERLOAD (obj AS objects_) AS INTEGER

   #DEFINE walkable_tile 63

   DIM AS INTEGER result, grid_x, grid_y, grid_x_offset, grid_y_offset

   result = TRUE ' walkable at first. then set not walkable as something blocks the way

   WITH obj
      grid_x        = .x \ 32
      grid_y        = .y \ 32
      grid_x_offset = .x MOD 32
      grid_y_offset = .y MOD 32

      SELECT CASE .face
         CASE facing_right
            IF (grid_x >= 20) OR (grid_x < -1) OR (grid_y >= 15) OR (grid_y < 0) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_y_offset = 0 THEN 'stepped on one tile. check 1 tile right
                  IF grid_x_offset = 0 THEN
                     IF grid_x <= 18 THEN result = (town_walkable_map(grid_x + 1, grid_y) = walkable_grid)
                  END IF
               ELSE 'stepped on two tiles. check 1 tile right and its below tile
                  IF grid_x_offset = 0 THEN
                     IF grid_x <= 18 THEN
                        result     = (town_walkable_map(grid_x + 1, grid_y    ) = walkable_grid)
                        result AND = (town_walkable_map(grid_x + 1, grid_y + 1) = walkable_grid)
                     END IF
                  END IF
               END IF
            END IF

         CASE facing_left
            IF (grid_x > 20) OR (grid_x < 0) OR (grid_y >= 15) OR (grid_y < 0) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_y_offset = 0 THEN 'stepped on one tile. check 1 tile left
                  IF grid_x_offset = 0 THEN
                     IF grid_x >= 1 THEN result = (town_walkable_map(grid_x - 1, grid_y) = walkable_grid)
                  END IF

               ELSE 'stepped on two tiles. check 1 tile left and its below tile
                  IF grid_x_offset = 0 THEN
                     IF grid_x >= 1 THEN
                        result     = (town_walkable_map(grid_x - 1, grid_y    ) = walkable_grid)
                        result AND = (town_walkable_map(grid_x - 1, grid_y + 1) = walkable_grid)
                     END IF
                  END IF
               END IF
            END IF

         CASE facing_up
            IF (grid_x >= 20) OR (grid_x < 0) OR (grid_y >  15) OR (grid_y <0) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_x_offset = 0 THEN 'stepped on one tile. check 1 tile above
                  IF grid_y_offset = 0 THEN
                     IF grid_y >= 1 THEN result = (town_walkable_map(grid_x, grid_y - 1) = walkable_grid)
                  END IF
               ELSE 'stepped on two tiles. check 1 tile above and its right tile
                  IF grid_y_offset = 0 THEN
                     IF grid_y >= 1 THEN
                        result     = (town_walkable_map(grid_x    , grid_y - 1) = walkable_grid)
                        result AND = (town_walkable_map(grid_x + 1, grid_y - 1) = walkable_grid)
                     END IF
                  END IF
               END IF
            END IF

         CASE facing_down
            IF (grid_x >= 20) OR (grid_x < 0) OR (grid_y >=  15) OR (grid_y < -1) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_x_offset = 0 THEN 'stepped on one tile. check 1 tile below
                  IF grid_y_offset = 0 THEN
                     IF grid_y <=  13 THEN result = (town_walkable_map(grid_x, grid_y + 1) = walkable_grid)
                  END IF
               ELSE 'stepped on two tiles. check 1 tile below and its right tile
                  IF grid_y_offset = 0 THEN
                     IF grid_y <=  13 THEN
                        result     = (town_walkable_map(grid_x    , grid_y + 1) = walkable_grid)
                        result AND = (town_walkable_map(grid_x + 1, grid_y + 1) = walkable_grid)
                     END IF
                  END IF
               END IF
            END IF
      END SELECT

   END WITH

   RETURN result

END FUNCTION

SUB WALK(BYREF obj AS objects_, direction AS INTEGER, steps AS INTEGER = 0)

   WITH obj
      .face = direction
      SELECT CASE .face
         CASE facing_up
            IF WALKABLE(obj) THEN
               .y -= steps
            ELSE
               GO_AROUND(obj, steps) 'based on internal obj.face direction, go around obstacle
            END IF

         CASE facing_right
            IF WALKABLE(obj) THEN
               .x += steps
            ELSE
               GO_AROUND(obj, steps)
            END IF

         CASE facing_down
            IF WALKABLE(obj) THEN
               .y += steps
            ELSE
               GO_AROUND(obj, steps)
            END IF

         CASE facing_left
            IF WALKABLE(obj) THEN
               .x -= steps
            ELSE
               GO_AROUND(obj, steps)
            END IF

      END SELECT
   END WITH
END SUB


SUB DISPLAY_DOOR()

   'check wall type. if valid space, door or block can be built there.
   'if locked, display locked box
   'if blueblocked, display blue block.

   #DEFINE block_top  106
   #DEFINE lock_top   107
   #DEFINE lock_wall  108

   IF (stat.wall_info AND 1) = 0 THEN 'valid top space. door can be built.
      'put locked door
      IF stat.door_u_state = DOOR_LOCKED THEN
         PUT_TILE( 8*32, 0*32, lock_top)
         PUT_TILE( 9*32, 0*32, lock_top)
         PUT_TILE(10*32, 0*32, lock_top)
         PUT_TILE(11*32, 0*32, lock_top)
         PUT_TILE( 8*32, 1*32, lock_wall)
         PUT_TILE( 9*32, 1*32, lock_wall)
         PUT_TILE(10*32, 1*32, lock_wall)
         PUT_TILE(11*32, 1*32, lock_wall)
      END IF
      'put blue block
      IF stat.door_u_state = door_blocked THEN
         PUT_TILE( 8*32, 0*32, block_top)
         PUT_TILE( 9*32, 0*32, block_top)
         PUT_TILE(10*32, 0*32, block_top)
         PUT_TILE(11*32, 0*32, block_top)
         PUT_TILE( 8*32, 1*32, lock_wall)
         PUT_TILE( 9*32, 1*32, lock_wall)
         PUT_TILE(10*32, 1*32, lock_wall)
         PUT_TILE(11*32, 1*32, lock_wall)
      END IF
   END IF


   IF (stat.wall_info AND 2) = 0 THEN 'valid right space. door can be built.
      IF stat.door_r_state = DOOR_LOCKED THEN
         PUT_TILE(19*32, 5*32, block_top)
         PUT_TILE(19*32, 6*32, lock_top)
         PUT_TILE(19*32, 7*32, lock_top)
         PUT_TILE(19*32, 8*32, lock_top)
      END IF

      IF stat.door_r_state = door_blocked THEN
         PUT_TILE(19*32, 5*32, block_top)
         PUT_TILE(19*32, 6*32, block_top)
         PUT_TILE(19*32, 7*32, block_top)
         PUT_TILE(19*32, 8*32, block_top)
      END IF

   END IF


   IF (stat.wall_info AND 4) = 0 THEN 'valid bottom space. door can be built.
      IF stat.door_d_state = DOOR_LOCKED THEN
         PUT_TILE( 8*32, 14*32, lock_top)
         PUT_TILE( 9*32, 14*32, lock_top)
         PUT_TILE(10*32, 14*32, lock_top)
         PUT_TILE(11*32, 14*32, lock_top)
      END IF

      IF stat.door_d_state = door_blocked THEN
         PUT_TILE( 8*32, 14*32, block_top)
         PUT_TILE( 9*32, 14*32, block_top)
         PUT_TILE(10*32, 14*32, block_top)
         PUT_TILE(11*32, 14*32, block_top)
      END IF

   END IF


   IF (stat.wall_info AND 8) = 0 THEN 'valid left space. door can be built.
      IF stat.door_l_state = DOOR_LOCKED THEN
         PUT_TILE(0*32, 5*32, block_top)
         PUT_TILE(0*32, 6*32, lock_top)
         PUT_TILE(0*32, 7*32, lock_top)
         PUT_TILE(0*32, 8*32, lock_top)
      END IF

      IF stat.door_l_state = door_blocked THEN
         PUT_TILE(0*32, 5*32, block_top)
         PUT_TILE(0*32, 6*32, block_top)
         PUT_TILE(0*32, 7*32, block_top)
         PUT_TILE(0*32, 8*32, block_top)
      END IF

   END IF


   IF (stat.wall_info AND 16) = 0 THEN 'wall is valid?
      'valid zoo space. door can be built.
      IF stat.door_z_state = DOOR_LOCKED THEN
         PUT_TILE(19*32, 12*32, block_top)
         PUT_TILE(19*32, 13*32, lock_top)

      END IF

      IF stat.door_z_state = door_blocked THEN
         PUT_TILE(19*32, 12*32, block_top)
         PUT_TILE(19*32, 13*32, block_top)
      END IF
   END IF

END SUB

FUNCTION CHECK_LOCKED_DOOR OVERLOAD (obj AS objects_, direction AS INTEGER) AS INTEGER

   #DEFINE walkable_tile 63

   DIM AS INTEGER result, grid_x, grid_y, grid_x_offset, grid_y_offset

   result = FALSE

   WITH obj
      grid_x        = .x \ 32
      grid_y        = .y \ 32
      grid_x_offset = .x MOD 32
      grid_y_offset = .y MOD 32

      SELECT CASE direction
         CASE facing_right
            IF (grid_x >= 20) OR (grid_x < -1) OR (grid_y >= 15) OR (grid_y < 0) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_y_offset = 0 THEN 'stepped on one tile. check 1 tile right
                  IF grid_x_offset = 0 THEN
                     IF grid_x <= 18 THEN result = (town_walkable_map(grid_x + 1, grid_y) = locked_door)
                  END IF
               ELSE 'stepped on two tiles. check 1 tile right and its below tile
                  IF grid_x_offset = 0 THEN
                     IF grid_x <= 18 THEN
                        result     = (town_walkable_map(grid_x + 1, grid_y    ) = locked_door)
                        result OR = (town_walkable_map(grid_x + 1, grid_y + 1) = locked_door)
                     END IF
                  END IF
               END IF
            END IF

         CASE facing_left
            IF (grid_x > 20) OR (grid_x < 0) OR (grid_y >= 15) OR (grid_y < 0) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_y_offset = 0 THEN 'stepped on one tile. check 1 tile left
                  IF grid_x_offset = 0 THEN
                     IF grid_x >= 1 THEN result = (town_walkable_map(grid_x - 1, grid_y) = locked_door)
                  END IF

               ELSE 'stepped on two tiles. check 1 tile left and its below tile
                  IF grid_x_offset = 0 THEN
                     IF grid_x >= 1 THEN
                        result     = (town_walkable_map(grid_x - 1, grid_y    ) = locked_door)
                        result OR = (town_walkable_map(grid_x - 1, grid_y + 1) = locked_door)
                     END IF
                  END IF
               END IF
            END IF

         CASE facing_up
            IF (grid_x >= 20) OR (grid_x < 0) OR (grid_y >  15) OR (grid_y < 0) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_x_offset = 0 THEN 'stepped on one tile. check 1 tile above
                  IF grid_y_offset = 0 THEN
                     IF grid_y >= 1 THEN result = (town_walkable_map(grid_x, grid_y - 1) = locked_door)
                  END IF
               ELSE 'stepped on two tiles. check 1 tile above and its right tile
                  IF grid_y_offset = 0 THEN
                     IF grid_y >= 1 THEN
                        result     = (town_walkable_map(grid_x    , grid_y - 1) = locked_door)
                        result OR = (town_walkable_map(grid_x + 1, grid_y - 1) = locked_door)
                     END IF
                  END IF
               END IF
            END IF

         CASE facing_down
            IF (grid_x >= 20) OR (grid_x < 0) OR (grid_y >=  15) OR (grid_y < -1) THEN 'if out of map range
               result = TRUE 'then, it is walkable
            ELSE
               IF grid_x_offset = 0 THEN 'stepped on one tile. check 1 tile below
                  IF grid_y_offset = 0 THEN
                     IF grid_y <=  13 THEN result = (town_walkable_map(grid_x, grid_y + 1) = locked_door)
                  END IF
               ELSE 'stepped on two tiles. check 1 tile below and its right tile
                  IF grid_y_offset = 0 THEN
                     IF grid_y <=  13 THEN
                        result     = (town_walkable_map(grid_x    , grid_y + 1) = locked_door)
                        result OR = (town_walkable_map(grid_x + 1, grid_y + 1) = locked_door)
                     END IF
                  END IF
               END IF
            END IF
      END SELECT

   END WITH

   RETURN result

END FUNCTION


SUB SET_HP_BAR(obj AS objects_, hp AS INTEGER = 100)

   WITH obj
      .hp = hp
      IF hp <= 0 THEN
         .hp_timer = 50 'hp bar will be displayed shorter if there is no HP...
      ELSE
         .hp_timer = 120 'hp bar will be displayed this long...
      END IF

      .hp_alpha = 255 'hp bar alpha level
   END WITH

END SUB

SUB SET_MP_BAR(obj AS objects_, mp AS INTEGER = 100)

   WITH obj
      .mp = mp
      IF mp = 0 THEN
         .mp_timer = 50 'hp bar will be displayed shorter if there is no HP...
      ELSE
         .mp_timer = 120 'hp bar will be displayed this long...
      END IF

      .mp_alpha = 255 'hp bar alpha level
   END WITH

END SUB



SUB DISPLAY_HP_BAR(obj AS objects_, thickness AS INTEGER = 0)

   #DEFINE unit 28 'resizable hp bar length.
   'position offset
   #DEFINE ofs_X + 2
   #DEFINE ofs_Y + 25

   DIM AS INTEGER hp_x, hp_y, max_hp, max_33_percent

   WITH obj
      'if hp display timer is still activated. display (or HP is below 33%... always display HP bar)

      max_hp = IIF(.chara_type = people_type, stat.max_HP, 100)
      max_33_percent = IIF(.chara_type = people_type, (stat.max_HP\3), 33)

      IF (.hp_timer > 0) OR (.hp < max_33_percent) THEN

         IF .hp > max_33_percent OR .hp = 0 THEN
            .hp_timer -= 1 'decrease the display timer

            IF .hp_timer < 70 THEN .hp_alpha -= 4  ' let's fade hp bar this much at a time.
            IF .hp_alpha <  0 THEN .hp_alpha = 0     ' if out of range, 100% disappear

         END IF

         'precalculate hp bar position.
         hp_x = .x + ofs_x
         hp_y = .y + ofs_y

         'calculate bar length in 'n' unit.
         DIM AS INTEGER bar = INT((unit / max_hp) * .hp)

         'yellow hp bar
         IF .hp <> 0 THEN LINE (hp_x      , hp_y-thickness)-(hp_x +  bar, hp_y + 2+thickness),RGBA(255,255,0,.hp_alpha),bf
         'red hp bar
         IF .hp<>max_hp THEN LINE (hp_x + bar, hp_y-thickness)-(hp_x + unit, hp_y + 2+thickness),RGBA(255,  0,0,.hp_alpha),bf

         'hp bar frame
         LINE(hp_x-1,hp_y-1-thickness)-(hp_x+unit,hp_y+3+thickness),RGBA(0,0,0,.hp_alpha),b

      END IF

   END WITH
END SUB

SUB DISPLAY_MP_BAR(obj AS objects_)

   #DEFINE unit 28 'resizable hp bar length.
   'position offset
   #DEFINE ofs_X + 2
   #DEFINE ofs_Y + 25-8-8

   DIM AS INTEGER mp_x, mp_y

   WITH obj
      'if mp display timer is still activated. display (or MP is below 33%... always display MP bar)
      IF (.mp_timer > 0) OR (.mp < 165) THEN

         IF .mp > 165 OR .mp = 0 THEN
            .mp_timer -= 1 'decrease the display timer

            IF .mp_timer < 70 THEN .mp_alpha -= 4  ' let's fade hp bar this much at a time.
            IF .mp_alpha <  0 THEN .mp_alpha = 0     ' if out of range, 100% disappear

         END IF

         'precalculate hp bar position.
         mp_x = .x + ofs_x
         mp_y = .y + ofs_y

         'calculate bar length in 'n' unit.
         DIM AS INTEGER bar = INT((unit / 500) * .mp)

         'green mp bar
         IF .mp <> 0 THEN LINE (mp_x      , mp_y)-(mp_x +  bar, mp_y + 2),RGBA(0,255,0,.mp_alpha),bf
         'red mp bar
         IF .mp<>100 THEN LINE (mp_x + bar, mp_y)-(mp_x + unit, mp_y + 2),RGBA(255,  0,0,.mp_alpha),bf

         'mp bar frame
         LINE(mp_x-1,mp_y-1)-(mp_x+unit,mp_y+3),RGBA(0,0,0,.mp_alpha),b

      END IF

   END WITH
END SUB




SUB ADD_SPARK(x AS INTEGER ,y AS INTEGER ,spark_type AS INTEGER = 0)

   DIM AS INTEGER slot_found = -1, i

   'search for unused spark slot
   i = -1
   DO
      i += 1
      IF NOT spark(i).used THEN slot_found = i
   LOOP UNTIL slot_found > -1 OR i = max_spark_limit

   'if found empty slot...then use that slot to initialize spark
   IF slot_found <> -1 THEN
      spark(slot_found).used = TRUE
      spark(slot_found).x = x
      spark(slot_found).y = y
      spark(slot_found)._type = spark_type
      spark(slot_found)._TIMER = 15+2
      spark(slot_found).spr_ptn_ctr = 0
      spark(slot_found).spr_delay = 0
   END IF

END SUB

SUB DISPLAY_SPARK()

   'loop all spark array and update animation.display used spark. finish spark after enough time.

   FOR i AS INTEGER = 0 TO max_spark_limit

      WITH spark(i)
         IF  .used THEN 'display the spark only in 'used' state

            'process spark differently
            .spr_delay+=1

            IF .spr_delay>4 THEN
               .spr_delay =0
               .spr_ptn_ctr += 1
            END IF

            SELECT CASE ._type
               CASE spark_sun

                  .spr_ptn = .spr_ptn_ctr

                  IF .spr_ptn_ctr <=3 THEN
                     PUT(.x, .y), t_spark, (.spr_ptn*32, ._type*32)-(.spr_ptn*32+31, ._type*32+31), TRANS
                  END IF
                  IF .spr_ptn_ctr >3 THEN .used = FALSE

               CASE spark_dia
                  .spr_ptn = VAL(MID("01210", .spr_ptn_ctr+1, 1))
                  IF .spr_ptn_ctr <=4 THEN
                     PUT(.x, .y), t_spark, (.spr_ptn*32, ._type*32)-(.spr_ptn*32+31, ._type*32+31), TRANS
                  END IF
                  IF .spr_ptn_ctr >4 THEN .used = FALSE
            END SELECT

         END IF

      END WITH
   NEXT

END SUB


SUB ADD_FOOD(x AS INTEGER ,y AS INTEGER ,type_of_food AS INTEGER )

   DIM AS INTEGER slot_found, slot, i

   'normally, food will use index starting from 'food_min_bound'
   'key will use its own reserved slot.
   IF type_of_food = food_key THEN

      slot_found = TRUE
      slot = key_slot    'use reserved slot if it is key
      'PRINT_ "trying to add key"
   ELSE

      slot_found = FALSE

      'search for unused food slot starting from 1 to maxlimit
      i = (food_min_bound - 1)
      DO
         i += 1
         IF NOT chara(i).used THEN
            slot_found = TRUE
            slot = i
            'PRINT_ "index found at " & slot
         END IF
      LOOP UNTIL slot_found  OR i >= food_max_bound
   END IF

   'if found empty slot...
   IF slot_found THEN
      WITH chara(slot)
         .used = TRUE
         .chara_type = food_type 'also it is sprite tile pattern number.
         .spr_id = type_of_food 'parameter
         .x = x
         .y = y-1

         .bounce_max_y = -6    'bounce.
         .bounce_y = .bounce_max_y 'ach bounce will bounce this much.
         .bounce_timer = 200 'it will bounce through this much frames.
      END WITH

   END IF

END SUB


SUB ADD_PROJECTILE(parent_id AS INTEGER, x AS INTEGER ,y  AS INTEGER, direction AS INTEGER , projectile_id AS INTEGER )

   'depending onprojectile type, some are slash and other are flying stuff.
   'nope. no time to add both style. just use flying projectile.
   'search empty projectile slot and set it.
   DIM AS INTEGER slot_found, slot, i

   'normally, projectile will use index starting from 'projectile_min_bound'
   slot_found = FALSE

   'search for unused projectile slot starting from 1 to maxlimit
   i = (projectile_min_bound - 1)
   DO
      i += 1
      IF NOT chara(i).used THEN
         slot_found = TRUE
         slot = i
         'PRINT_ "index found at " & slot
      END IF
   LOOP UNTIL slot_found  OR i >= projectile_max_bound

   'if found empty slot...
   IF slot_found THEN
      'PRINT_ "trying to add Projectile at #" & slot

      WITH chara(slot)
         .used = TRUE
         .chara_type = projectile_type

         .parent = parent_id 'when this projectile is dead, call parent and free them to attack again.

         'call parent and tell them they've fired a projectile and hold any more attack.
         chara(.parent).fired = TRUE

         .face = direction 'projectile direction

         'set id, so process how it will act later.
         .id = projectile_id

         'set default sprite pattern
         SELECT CASE .id
            CASE projectile_slash    ' near : man, rom, knight
               .spr_id = projectile_slash
            CASE projectile_smash    ' near : cookie
               .spr_id = projectile_smash
            CASE projectile_fireball ' far : ghost, wwiz
               .spr_id = projectile_fireball
            CASE projectile_hadoken  ' far : cindy
               .spr_id = projectile_hadoken
         END SELECT

         'set projectile position
         .x = x
         .y = y
         .anim_ptn = 0
         .anim_ptn_ctr = 0

      END WITH
   END IF


END SUB

SUB PUT_PROJECTILE(x AS INTEGER ,y AS INTEGER ,face AS INTEGER, n AS INTEGER =0, pattern AS INTEGER = 0)

   DIM AS INTEGER image_x = (face * 32)
   DIM AS INTEGER image_y =  ((n*2)+pattern) * 32

   PUT(x,y), t_projectile, (image_x,image_y)-(image_x+31,image_y+31), TRANS

END SUB



SUB SHADOW_FONT (x AS INTEGER ,y AS INTEGER ,text AS STRING, alpha_level AS INTEGER = 255)
   DRAW STRING (x + 1, y + 1), text, RGBA(  0,   0,   0, alpha_level)
   DRAW STRING (x    , y    ), text, RGBA(255, 255, 255, alpha_level)
END SUB

SUB ADD_CHANGEV()


   ' chv is same Y as player. will jump down from from sky.
   ' special dy used as jumping height
   ' animation cycles 0 to 7 until hit ground. then use pattern #8
   '

END SUB


SUB ASK_QUIT(BYREF result AS INTEGER)
   'after quit action is triggered, ask one more time to confirm. skip this if 'quick quit' is set.

   #IFDEF quick_quit
   PRINT_ "quick quit is set."
   'do nothing. skip asking.

   #ELSE

   DIM AS INTEGER esc_released = FALSE, canceled = FALSE,  not_holding

   DIM AS JOYPAD j1

   'clear keyboard buffer
   WHILE INKEY <> "": WEND

   'pause until joypad button holding is done.
   DO
      j1.poll()
   LOOP while j1.button


   PRINT_ "asking quit"

   SCREENLOCK
   LINE(0,0)-(639,479), &haf000000,bf

   #DEFINE mdx 160
   #DEFINE mdy 339

   'medal information

   'LINE(mdx+2,mdy-3)-(mdx+150,mdy+105), &h4fffffff,bf
   LINE(mdx+2,mdy-3)-(mdx+151,mdy+101), RGBA(0,128,255,127),bf

   'angled lines
   LINE(70+11*0,450)-(70+11*0,mdy+3+13*0),RGBA(255,255,255,IIF(medal.no_miss, 255, 64))
   : LINE -(158,mdy+3+13*0),RGBA(255,255,255,IIF(medal.no_miss, 255, 64))
   LINE(70+11*1,450)-(70+11*1,mdy+3+13*1),RGBA(255,255,255,IIF(medal.find_candy, 255, 64))
   : LINE -(158,mdy+3+13*1),RGBA(255,255,255,IIF(medal.find_candy, 255, 64))
   LINE(70+11*2,450)-(70+11*2,mdy+3+13*2),RGBA(255,255,255,IIF(medal.MiniRPG, 255, 64))
   : LINE -(158,mdy+3+13*2),RGBA(255,255,255,IIF(medal.MiniRPG, 255, 64))
   LINE(70+11*3,450)-(70+11*3,mdy+3+13*3),RGBA(255,255,255,IIF(medal.break_99_object, 255, 64))
   : LINE -(158,mdy+3+13*3),RGBA(255,255,255,IIF(medal.break_99_object, 255, 64))
   LINE(70+11*4,450)-(70+11*4,mdy+3+13*4),RGBA(255,255,255,IIF(medal.kill_10_knight, 255, 64))
   : LINE -(158,mdy+3+13*4),RGBA(255,255,255,IIF(medal.kill_10_knight, 255, 64))
   LINE(70+11*5,447)-(70+11*5,mdy+3+13*5),RGBA(255,255,255,IIF(medal.kill_10_female, 255, 64))
   : LINE -(158,mdy+3+13*5),RGBA(255,255,255,IIF(medal.kill_10_female, 255, 64))
   LINE(70+11*6,447)-(70+11*6,mdy+3+13*6),RGBA(255,255,255,IIF(medal.kill_10_male, 255, 64))
   : LINE -(158,mdy+3+13*6),RGBA(255,255,255,IIF(medal.kill_10_male, 255, 64))
   LINE(70+11*7,447)-(70+11*7,mdy+3+13*7),RGBA(255,255,255,IIF(medal.get_key, 255, 64))
   : LINE -(158,mdy+3+13*7),RGBA(255,255,255,IIF(medal.get_key, 255, 64))

   SHADOW_FONT mdx+5, mdy + 13 * 0, "No MISS clear",      IIF(medal.no_miss,         255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 1, "Find Candy",         IIF(medal.find_candy,      255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 2, "MiniRPG towns tour", IIF(medal.MiniRPG,         255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 3, "Break 99 objects",   IIF(medal.break_99_object, 255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 4, "Kill 10 knights",    IIF(medal.kill_10_knight,  255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 5, "Kill 10 females",    IIF(medal.kill_10_female,  255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 6, "Kill 10 males",      IIF(medal.kill_10_male,    255, 64)
   SHADOW_FONT mdx+5, mdy + 13 * 7, "Get first key",      IIF(medal.get_key,         255, 64)
   'medal

   PUT(2,450), t_status, (0,26)-(61,38),TRANS
   DRAW STRING (2+63,450), medal.list, &hffffff00,t_number


   'put "quit"
   PUT (251,220-60), t_quit, (0,0)-(138,32), TRANS

   DIM AS INTEGER cursor = 1, joy_dir

   'reset result.
   result = FALSE

   SCREENUNLOCK
   DO
      j1.poll()

      'check if holding joypad up or down
      IF joy_dir<> joy_up AND joy_dir<> joy_down THEN not_holding = TRUE

      joy_dir = j1.direction(0)


      'check if [Esc] is released.
      IF NOT MULTIKEY(SC_ESCAPE) THEN esc_released = TRUE
      IF ((MULTIKEY(SC_LEFT ) OR (joy_dir = joy_left ) AND not_holding)) AND (cursor = 1) THEN cursor = 0:mysound.play_SFX(sfx_click , channel_click)
      IF ((MULTIKEY(SC_RIGHT) OR (joy_dir = joy_right) AND not_holding)) AND (cursor = 0) THEN cursor = 1:mysound.play_SFX(sfx_click , channel_click)

      result = MULTIKEY(SC_Z) OR MULTIKEY(SC_SPACE) OR j1.button OR MULTIKEY(SC_ENTER)

      'don't process esc input until esckey is released
      IF esc_released THEN
         canceled = MULTIKEY(SC_ESCAPE)
      END IF

      'put "yes" and "no"
      PUT(250-40,280-60), t_quit, (0,33+33*cursor)-(81,33+33*cursor+32), TRANS
      PUT(300+60,280-60), t_quit, (82,33+33*(1-cursor))-(136+5,33+33*(1-cursor)+32), TRANS

      SLEEP 1

   LOOP UNTIL result OR canceled

   result = (cursor = 0) AND (NOT canceled)

   'clear keyboard buffer
   WHILE INKEY <> "": WEND

   'check if holding joypad button
DO: j1.poll(): SLEEP 1: LOOP WHILE j1.button

#ENDIF

END SUB

SUB DISPLAY_STATUS()

   #DEFINE hiscore_x 2
   #DEFINE hiscore_y 2
   #DEFINE score_x      30 '2
   #DEFINE score_y      17 '2
   #DEFINE medal_x      2 '2
   #DEFINE medal_y     450 '17
   #DEFINE time_x       2
   #DEFINE time_y     465
   #DEFINE credit_x   545
   #DEFINE credit_y   465

   'score
   PUT(score_x, score_y), t_status, (0, 0)-(54,12),TRANS
   DRAW STRING (score_x+63, score_y), ZEROfill(stat.score,8),, t_number

   'hi-score' not used
   PUT(hiscore_x,hiscore_y), t_status, (0,13)-(82,25),TRANS
   DRAW STRING (hiscore_x+91, hiscore_y), zerofill(stat.hiscore,8),, t_number

   'medal
   PUT(medal_x,medal_y), t_status, (0,26)-(61,38),TRANS
   DRAW STRING (medal_x+63,medal_y), medal.list, &hffffff00,t_number

   'zoo stage will not have the game timer
   IF stat.timer_display_on then
      PUT(time_x,time_y), t_status, (0,39)-(48,51),TRANS

      IF (stat.timer_flash \5) = 0 THEN
         DRAW STRING (time_x+49, time_y), minusfill(stat.game_time,3),, t_number
      ELSE
         DRAW STRING (time_x+49, time_y), minusfill(stat.game_time,3),, t_flash_number
      END IF

   END IF

   'credit
   PUT(credit_x,credit_y), t_status, (0,52)-(70,64),TRANS
   DRAW STRING (credit_x+71, credit_y), zerofill(stat.credit,2),, t_number

END SUB


SUB TITLE(BYREF result AS INTEGER)

   DIM AS STRING userinput
   DIM AS INTEGER canceled, selection = 0, selected, x, y, z = 2, joy_dir
   DIM AS INTEGER mx, my, not_holding
   DIM AS JOYPAD j1
   DIM AS SINGLE skx(2), sky(2), skdx(2), skdy(2)

   skx(0)  = 300: sky(0)  = 180
   skdx(0) =  -1: skdy(0) =   1

   skx(1)  = 187: sky(1)  = 307
   skdx(1) = 1.4: skdy(1) =  .5

   skx(2)  = 418: sky(2)  = 262
   skdx(2) = -.3: skdy(2) =  .8

   'clear keyboard buffer just in case
   WHILE INKEY <> "": WEND

   'load title background
   BLOAD "gfx\combine.bmp", t_shadow

   DO

      j1.poll()

      'check if holding joypad up or down
      IF joy_dir<> joy_up AND joy_dir<> joy_down THEN not_holding = TRUE

      joy_dir = j1.direction(0)
      userinput = INKEY

      'up
      IF userinput = CHR(255, 72) OR (joy_dir = joy_up AND not_holding)THEN
         selection -= 1
         'IF (NOT stat.arena) AND selection = 1 THEN selection -= 1
         IF selection < 0 THEN selection = 0 ELSE mysound.play_SFX(sfx_click , channel_click)
         not_holding= FALSE
      END IF

      'down
      IF userinput = CHR(255,80) OR (joy_dir = joy_down  AND not_holding)THEN
         selection += 1
         'IF (NOT stat.arena) AND selection = 1 THEN selection += 1
         IF selection > 2 THEN selection = 2 ELSE mysound.play_SFX(sfx_click, channel_click)
         not_holding= FALSE

      END IF

      selected = INSTR(CHR(13, 32, 27, 90, 122),userinput ) > 0 OR j1.button
      canceled = userinput = CHR(27) OR (userinput = CHR(255, 107))

      skx(0) += skdx(0)
      IF skx(0) < 103 THEN skdx(0) = +ABS(skdx(0))
      IF skx(0) > 490 THEN skdx(0) = -ABS(skdx(0))
      sky(0) += skdy(0)
      IF sky(0) < 180 THEN skdy(0) = +ABS(skdy(0))
      IF sky(0) > 343 THEN skdy(0) = -ABS(skdy(0))

      skx(1) += skdx(1)
      IF skx(1) < 157 THEN skdx(1) = +ABS(skdx(1))
      IF skx(1) > 435 THEN skdx(1) = -ABS(skdx(1))
      sky(1) += skdy(1)
      IF sky(1) < 126 THEN skdy(1) = +ABS(skdy(1))
      IF sky(1) > 333 THEN skdy(1) = -ABS(skdy(1))

      skx(2) += skdx(2)
      IF skx(2) < 103 THEN skdx(2) = +ABS(skdx(2))
      IF skx(2) > 490 THEN skdx(2) = -ABS(skdx(2))
      sky(2) += skdy(2)
      IF sky(2) < 180 THEN skdy(2) = +ABS(skdy(2))
      IF sky(2) > 343 THEN skdy(2) = -ABS(skdy(2))

      'output
      SCREENLOCK

      PUT(0, 0), t_shadow, PSET

      x = 273-7
      y = 377

      IF selection = 0 THEN
         PUT(x, y), t_menu_big, (0, 0)-(108, 21), trans
         y += 22+z
      ELSE
         PUT(x+25, y), t_menu_small, (0, 0)-(56, 10), TRANS
         y += 11+z
      END IF

      IF selection = 1 THEN
         PUT(x, y), t_menu_big, (0, 22)-(108, 43), TRANS
         y += 22+z
      ELSE
         PUT(x+25, y), t_menu_small, (0, 11)-(56, 21), TRANS
         y += 11+z
      END IF

      IF selection = 2 THEN
         PUT(x , y), t_menu_big, (0, 44)-(108, 65), TRANS
         y += 22+z
      ELSE
         PUT(x+25, y), t_menu_small, (0, 22)-(56, 32), TRANS
         y += 11+z
      END IF


      PUT_PLAYER(skx(0)+12,290+sky(0)\5,0,0,t_trail)
      PUT_PLAYER(skx(1)+12,280+sky(1)\5,0,0,t_trail)
      PUT_PLAYER(skx(2)+12,290+sky(2)\5,0,0,t_trail)

      PUT (skx(0),sky(0)), t_skull, (0,0)-(45,27),ALPHA, 150
      PUT (skx(1),sky(1)), t_skull, (0,28)-(45,55),ALPHA, 150
      PUT (skx(2),sky(2)), t_skull, (0,0)-(45,27),ALPHA, 150


      PUT (256, 240), t_eye , TRANS
      PUT (352, 240), t_eye, TRANS

      'add hiscore somewhere on screen
      'hi-score'
      PUT(2,2), t_status, (0,13)-(82,25),TRANS
      DRAW STRING (2+91, 2), zerofill(stat.hiscore,8),, t_number

      SCREENUNLOCK

      IF NOT MULTIKEY(SC_M) THEN SLEEP 10,1
      'LOOP UNTIL quit OR INSTR(" zZ" + CHR(13), userinput) > 0 OR j1.button

   LOOP UNTIL selected OR canceled OR userinput = CHR(27)

   'clear keyboard buffer
   WHILE INKEY <> "": WEND

   'check if holding joypad button
   DO
      j1.poll()

   LOOP WHILE j1.button

   IF canceled OR selection = 2 THEN
      result = quit_game
   ELSE
      result = IIF (selection = 0, start_game, arena_game)
      mysound.play_SFX(sfx_punch, channel_punch)
   END IF

END SUB


SUB no_continue()

   #DEFINE wx  240
   #DEFINE wy  180

   DIM AS STRING userinput
   DIM AS JOYPAD j1
   DIM AS INTEGER joy_dir, n, scroll_x=0, scroll_x_delay =0
   DIM AS INTEGER cursor = 0
   DIM AS INTEGER chv_x   = wx   -50, chv_y   = wy+80, chv_ptn  =0, chv_ctr   = 0
   DIM AS INTEGER slime_x = chv_x -5, slime_y = chv_y, slime_ptn=0, slime_ctr = 0, slime_dx = 6, slime_dx_ctr=0

   'make screen darker
   LINE(0,0)-(639,479), &haf000000,bf


   FOR i AS INTEGER = 0 TO 360
      scroll_x_delay+= 1
      IF scroll_x_delay > 2 THEN
         scroll_x_delay = 0
         chv_x+=2
         slime_x+=2
      END IF

      SCREENLOCK
      'stopped background
      PUT(wx,wy), t_forest, (scroll_x,0)-(scroll_x+159,159), pset

      chv_ctr+=1
      IF chv_ctr>20 THEN
         chv_ctr = 0
         chv_ptn+=1
         IF chv_ptn>1 THEN chv_ptn = 0
      END IF

      slime_ctr+=1
      IF slime_ctr>20 THEN
         slime_ctr = 0
         slime_ptn+=1
         IF slime_ptn>1 THEN slime_ptn = 0
      END IF

      VIEW SCREEN (wx,wy)-(wx+159,wy+159)

      'slime
      PUT(slime_x,slime_y),  t_c_slime, (0,slime_ptn*30)-(36,slime_ptn*30+29), ALPHA, 150
      'changev
      PUT(chv_x,chv_y),  t_c_chv, (0,chv_ptn*30)-(54,chv_ptn*30+29), TRANS

      VIEW

      SLEEP 10,1
      SCREENUNLOCK
   NEXT

END SUB


SUB ASK_CONTINUE(BYREF result AS INTEGER)

   #DEFINE wx  240
   #DEFINE wy  180

   #DEFINE nn 30

   DIM AS STRING userinput
   DIM AS JOYPAD j1
   DIM AS INTEGER joy_dir, n, scroll_x=0, scroll_x_delay =0
   DIM AS INTEGER cursor = 0, not_holding
   DIM AS INTEGER chv_x   = wx   +60, chv_y   = wy+80, chv_ptn  =0, chv_ctr   = 0
   DIM AS INTEGER slime_x = chv_x -5, slime_y = chv_y, slime_ptn=0, slime_ctr = 0, slime_dx = 6, slime_dx_ctr=0

   'clear keyboard buffer
   WHILE INKEY <> "": WEND


   'check if space or enter key is pressed
   DO
   LOOP WHILE MULTIKEY(SC_SPACE)

   DO
   LOOP WHILE MULTIKEY(SC_ENTER)

   DO
      j1.poll()
   LOOP UNTIL j1.button(stat.menu_button) = 0

   SCREENLOCK
   'make screen darker
   LINE(0,0)-(639,479), &haf000000,bf
   SCREENUNLOCK

   'reset result.
   result = FALSE

   'reset clip area
   VIEW

   DO
      j1.poll()

      'check if holding joypad up or down
      IF joy_dir<> joy_up AND joy_dir<> joy_down THEN not_holding = TRUE

      joy_dir = j1.direction(0)

      IF ((MULTIKEY(SC_LEFT ) OR (joy_dir = joy_left ) AND not_holding)) AND (cursor = 1) THEN cursor = 0:mysound.play_SFX(sfx_click , channel_click)
      IF ((MULTIKEY(SC_RIGHT) OR (joy_dir = joy_right) AND not_holding)) AND (cursor = 0) THEN cursor = 1:mysound.play_SFX(sfx_click , channel_click)

      result = MULTIKEY(SC_Z) OR MULTIKEY(SC_SPACE) OR j1.button(stat.attack_button) OR MULTIKEY(SC_ENTER)

      scroll_x_delay+= 1
      IF scroll_x_delay > 2 THEN
         scroll_x_delay = 0

         scroll_x+=1
         IF scroll_x >480 THEN scroll_x = 0

      END IF

      SCREENLOCK

      'animated background
      PUT(wx,wy), t_forest, (scroll_x,0)-(scroll_x+159,159), pset

      chv_ctr+=1
      IF chv_ctr>20 THEN
         chv_ctr = 0
         chv_ptn+=1
         IF chv_ptn>1 THEN chv_ptn = 0
      END IF

      slime_ctr+=1
      IF slime_ctr>20 THEN
         slime_ctr = 0
         slime_ptn+=1
         IF slime_ptn>1 THEN slime_ptn = 0
      END IF

      'slime
      PUT(slime_x,slime_y),  t_c_slime, (0,slime_ptn*30)-(36,slime_ptn*30+29), ALPHA, 150
      'changev
      PUT(chv_x,chv_y),  t_c_chv, (0,chv_ptn*30)-(54,chv_ptn*30+29), TRANS

      'put "continue"
      PUT ( wx-42,wy-40), t_continue, TRANS

      'put "yes" and "no"
      PUT(wx    -20,wy+165), t_quit, (0,33+33*cursor)-(81,33+33*cursor+32), TRANS
      PUT(wx+100+20,wy+165), t_quit, (82,33+33*(1-cursor))-(136+5,33+33*(1-cursor)+32), TRANS
      SLEEP 10,1
      SCREENUNLOCK
   LOOP UNTIL result

   result =  cursor = 0

   SELECT CASE result
      CASE TRUE 'slime escape from changeV
         slime_ctr = 0
         LINE(wx,wy)-(wx+159,wy+159), &hff333333,bf

         DO
            scroll_x_delay+= 1
            IF scroll_x_delay > 2 THEN
               scroll_x_delay = 0
               IF slime_ctr>11 THEN
                  chv_x+=2
               ELSE
                  scroll_x+=1
                  IF scroll_x >480 THEN scroll_x = 0

               END IF

            END IF

            screenlock

            'stopped background
            PUT(wx,wy), t_forest, (scroll_x,0)-(scroll_x+159,159), pset

            chv_ctr+=1
            IF chv_ctr>20 THEN
               chv_ctr = 0
               chv_ptn+=1
               IF chv_ptn>1 THEN chv_ptn = 0
            END IF

            slime_ctr+=1

            SELECT CASE slime_ctr
               CASE 0 TO 5: slime_ptn = 2
               CASE 6 TO 11: slime_ptn = 3
               CASE 12 TO 17: slime_ptn = 4
               CASE 40+nn: slime_ptn = 2
               CASE 46+nn: slime_ptn = 5
               CASE 52+nn: slime_ptn = 5
               CASE 90+nn: slime_ptn = 6
               CASE 95+nn: slime_ptn = 7
               CASE 120+nn TO 140+nn:
                  slime_dx_ctr+=1
                  IF slime_dx_ctr>3 THEN
                     slime_dx_ctr = 0
                     slime_dx -= 1
                     IF slime_dx < -5 THEN slime_dx = -5

                     slime_x += slime_dx
                  END IF
               CASE IS > 140+nn:
                  slime_dx_ctr+=1
                  IF slime_dx_ctr>1 THEN
                     slime_dx_ctr = 0
                     slime_dx -= 1

                     slime_x += slime_dx
                  END IF

            END SELECT


            VIEW SCREEN (wx,wy)-(wx+159,wy+159)

            'slime
            PUT(slime_x,slime_y),  t_c_slime, (0,slime_ptn*30)-(36,slime_ptn*30+29), ALPHA, 150
            PUT(chv_x,chv_y),  t_c_chv, (0,(IIF(slime_Ctr<=11,0,2)+chv_ptn)*30)-(54,(IIF(slime_Ctr<=11,0,2)+chv_ptn)*30+29), TRANS

            VIEW

            'put "continue"
            PUT ( wx-42,wy-40), t_continue, TRANS

            'put "yes" and "no"
            PUT(wx    -20,wy+165), t_quit, (0,33+33*cursor)-(81,33+33*cursor+32), TRANS
            PUT(wx+100+20,wy+165), t_quit, (82,33+33*(1-cursor))-(136+5,33+33*(1-cursor)+32), TRANS

            SLEEP 10,1
            IF MULTIKEY(SC_LSHIFT) THEN SLEEP 1000,1

            SCREENUNLOCK
         LOOP UNTIL slime_x < wx-32-50-1000 OR INKEY = CHR(27)

      CASE FALSE
         FOR i AS INTEGER = 0 TO 160

            scroll_x_delay+= 1
            IF scroll_x_delay > 2 THEN
               scroll_x_delay = 0
               chv_x+=2
               slime_x+=2
            END IF
            SCREENLOCK
            'stopped background
            PUT(wx,wy), t_forest, (scroll_x,0)-(scroll_x+159,159), pset

            chv_ctr+=1
            IF chv_ctr>20 THEN
               chv_ctr = 0
               chv_ptn+=1
               IF chv_ptn>1 THEN chv_ptn = 0
            END IF

            slime_ctr+=1
            IF slime_ctr>20 THEN
               slime_ctr = 0
               slime_ptn+=1
               IF slime_ptn>1 THEN slime_ptn = 0
            END IF

            VIEW SCREEN (wx,wy)-(wx+159,wy+159)

            'slime
            PUT(slime_x,slime_y),  t_c_slime, (0,slime_ptn*30)-(36,slime_ptn*30+29), ALPHA, 150
            'changev
            PUT(chv_x,chv_y),  t_c_chv, (0,chv_ptn*30)-(54,chv_ptn*30+29), TRANS

            VIEW

            'put "continue"
            PUT ( wx-42,wy-40), t_continue, TRANS

            'put "yes" and "no"
            PUT(wx    -20,wy+165), t_quit, (0,33+33*cursor)-(81,33+33*cursor+32), TRANS
            PUT(wx+100+20,wy+165), t_quit, (82,33+33*(1-cursor))-(136+5,33+33*(1-cursor)+32), TRANS

            SLEEP 10,1
            SCREENUNLOCK
         NEXT

   END SELECT

   VIEW

   'clear keyboard buffer
   WHILE INKEY <> "": WEND

   'check if holding joypad button
   DO
      j1.poll(): SLEEP 1
   LOOP WHILE j1.button

END SUB


SUB CUT_SCENE(n AS INTEGER=0)
   DIM AS STRING userinput
   DIM AS fb.image PTR t_cut1, t_cut2, t_cut3
   DIM AS INTEGER cutscene_ended = FALSE
   DIM AS JOYPAD j1

   #DEFINE wx 240
   #DEFINE wy 180

   DIM AS INTEGER joy_dir, scroll_x=0, scroll_x_delay =0
   DIM AS INTEGER cursor = 0
   DIM AS INTEGER chv_x   = wx   -50-40, chv_y   = wy+80, chv_ptn  =0, chv_ctr   = 0
   DIM AS INTEGER slime_x = chv_x -5, slime_y = chv_y, slime_ptn=0, slime_ctr = 0, slime_dx = 6, slime_dx_ctr=0

   'screen shot captured. use it freely if needed.
   GET(0,0)-(639,479), t_shadow

   stat.cutscene_ctr = -1

   DO
      userinput = INKEY
      stat.cutscene_ctr += 1
      IF userinput = CHR(27) THEN cutscene_ended = TRUE
      SCREENLOCK
      SELECT CASE n
         CASE 0
         CASE 1
            IF stat.cutscene_ctr = 0 THEN
               t_cut1 = BMPLOAD("gfx\dragon.bmp")
               t_cut2= BMPLOAD("gfx\king.bmp")
               't_cut3= BMPLOAD("gfx\cut_balloon.bmp")
            END IF

            IF stat.cutscene_ctr = 110 THEN PUT(7*32,3*32), t_cut1,(96*0,0)-(96*0+95, 127), TRANS
            IF stat.cutscene_ctr = 120 THEN PUT(7*32,3*32), t_cut1,(96*1,0)-(96*1+95, 127), TRANS
            IF stat.cutscene_ctr = 130 THEN PUT(7*32,3*32), t_cut1,(96*2,0)-(96*2+95, 127), TRANS
            IF stat.cutscene_ctr = 140 THEN PUT(7*32,3*32), t_cut1,(96*3,0)-(96*3+95, 127), TRANS
            IF stat.cutscene_ctr = 200 THEN PUT(7*32,3*32), t_cut1,(96*4,0)-(96*4+95, 127), TRANS

            IF stat.cutscene_ctr = 320 THEN LINE(0,0)-(639,479),&hff000000,bf ''pause in black

            'then castle
            IF stat.cutscene_ctr = 380 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 450 THEN PUT (240+5,120-5 +11), t_balloon,(0,82)-(155,112),TRANS 'where is everyone?
            IF stat.cutscene_ctr = 550+30 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 630 THEN PUT (240+5,120-5), t_balloon,(0,113)-(155,153),TRANS 'my pet has eacaped
            IF stat.cutscene_ctr = 730+30 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 810 THEN PUT (240+5,120-5), t_balloon,(0,154)-(185,194),TRANS 'you know what?
            IF stat.cutscene_ctr = 910+30 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 990+50 THEN PUT (240+5,120-5), t_balloon,(0,195)-(124,235),TRANS 'need before you go?
            IF stat.cutscene_ctr = 1090+30+50 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 1100+30+50 THEN PUT (350,215), t_balloon,(146,0)-(187,49),TRANS 'rope
            IF stat.cutscene_ctr = 1250+100 THEN LINE(0,0)-(639,479),&hff000000,bf 'pause in black

            IF stat.cutscene_ctr >= 1310+100 THEN cutscene_ended = TRUE
            SLEEP 1,1        
         CASE 2

            'last stage cut scene
            IF stat.cutscene_ctr = 20 THEN
               'fade
               LINE(0,0)-(639,479), &haf000000,bf

               ' slime walking with 3x rope
               'reset clip area just in case
               VIEW
               FOR i AS INTEGER = 0  TO 420
                  SCREENUNLOCK
                  SCREENLOCK
                  'scroll or changev walking
                  scroll_x_delay+= 1
                  IF scroll_x_delay > 2 THEN
                     scroll_x_delay = 0
                     chv_x+=2
                  END IF

                  'animated background
                  PUT(wx,wy), t_forest, (scroll_x,0)-(scroll_x+159,159), pset

                  'changev animation pattern
                  chv_ctr+=1
                  IF chv_ctr>20 THEN
                     chv_ctr = 0
                     chv_ptn+=1
                     IF chv_ptn>1 THEN chv_ptn = 0
                  END IF

                  VIEW SCREEN (wx,wy)-(wx+159,wy+159)

                  'changev
                  PUT(chv_x,chv_y),  t_c_chv, (0,(4+chv_ptn)*30)-(54,(4+chv_ptn)*30+29), TRANS

                  VIEW
                  SLEEP 10,1
                  SCREENUNLOCK
                  SCREENLOCK
               NEXT

            END IF

            IF stat.cutscene_ctr = 0 THEN
               t_cut2 = BMPLOAD("gfx\ending.bmp")
               t_cut3 = BMPLOAD("gfx\theend.bmp")
            END IF

            IF stat.cutscene_ctr = 30 THEN LINE(0,0)-(639,479),&hff000000,bf 'clear screen

            IF stat.cutscene_ctr = 48 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 90 THEN PUT (290+5+15,120-5 +11), t_balloon,(0,347)-(76,375),TRANS 'good job
            IF stat.cutscene_ctr = 140 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 170 THEN PUT (290+5,120-5 +11-8 ), t_balloon,(0,376)-(155,414),TRANS 'but...
            IF stat.cutscene_ctr = 250 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 280 THEN PUT (290+5,120-5 +11-8), t_balloon,(0,415)-(147,455),TRANS 'see you..
            IF stat.cutscene_ctr = 380 THEN PUT (128,56), t_cut2,PSET 'king background

            IF stat.cutscene_ctr = 450 THEN
               LINE(0,0)-(639,479),&h7f000000,bf
               PUT (128+5,66+144), t_cut3,(0,0)-(165,65),TRANS 'THE
               PUT (346-5,66+144), t_cut3,(166,0)-(331,65),TRANS 'END
            END IF

            IF stat.cutscene_ctr = 550 THEN
               PUT (470+44,66+144), t_cut3,(332,0)-(385,65),trans '?
            END IF


        


            IF stat.cutscene_ctr = 780 THEN LINE(0,0)-(639,479), &hff000000,bf
            IF stat.cutscene_ctr = 800 THEN BLOAD"gfx\credit.bmp"

            IF stat.cutscene_ctr = 1200 THEN cutscene_ended = TRUE

            SLEEP 10,1

      END SELECT

      'press [Esc] key to skip cutscene
      
      SLEEP 10,1

      SCREENUNLOCK

   LOOP UNTIL cutscene_ended

   IF t_cut1 <> 0  THEN IMAGEDESTROY (t_cut1)
   IF t_cut2 <> 0  THEN IMAGEDESTROY (t_cut2)
   IF t_cut3 <> 0  THEN IMAGEDESTROY (t_cut3)

END SUB


SUB option_menu()

   DIM AS fb.image PTR t_option_menu, t_on_off
   DIM AS STRING userinput
   DIM AS INTEGER menu_row, menu_column = -(mysound.FMOD_is_disabled)
   DIM AS INTEGER back = FALSE, not_holding, joy_dir, btn_hold
   DIM AS joypad j1

   t_option_menu = BMPLOAD("gfx\option.bmp")
   t_on_off = BMPLOAD("gfx\onoff.bmp")

   DO
      userinput = INKEY

      IF j1.button = 0 THEN btn_hold = false
      j1.poll()

      'check if holding joypad up or down
      IF joy_dir<> joy_up AND joy_dir<> joy_down THEN not_holding = TRUE

      joy_dir = j1.direction(0)

      IF (userinput = CHR(255, 72) OR (joy_dir = joy_up AND not_holding)) AND menu_row > 0 THEN
         menu_row -= 1
         mysound.play_SFX(sfx_click, channel_click)
         not_holding= FALSE
      END IF

      IF (userinput = CHR(255, 80) OR (joy_dir = joy_down  AND not_holding)) AND menu_row < 4 THEN
         menu_row += 1
         mysound.play_SFX(sfx_click, channel_click)
         not_holding= FALSE
      END if

      'display part
      SCREENLOCK
      PUT(0,0), t_option_menu, PSET
      PUT(325,139), t_on_off, (0,33*menu_column)-(155,33*menu_column+32), PSET
      DRAW STRING (480,265), minusfill(stat.attack_button, 2),, t_number
      DRAW STRING (480,310), minusfill(stat.menu_button  , 2),, t_number

      SELECT CASE menu_row

         CASE 0' sound
            LINE(0,190)-(639,450), &hcf000000,bf
         CASE 1 'joy set action
            LINE(0,139)-(639,189), &hcf000000,bf
            LINE(0,290)-(639,450), &hcf000000,bf
         CASE 2 'joy set menu
            LINE(0,139)-(639,189), &hcf000000,bf

            LINE(0,333)-(639,450), &hcf000000,bf
            LINE(0,250)-(639,290), &hcf000000,bf

         CASE 3 'joy default
            LINE(0,139)-(639,189), &hcf000000,bf
            LINE(0,250)-(639,333), &hcf000000,bf
            LINE(256,400)-(390,450), &hcf000000,bf

         CASE 4 'back
            LINE(0,139)-(639,400), &hcf000000,bf
      END SELECT
      screenunlock

      'process part
      SELECT CASE menu_row


         CASE 0' sound
            IF (userinput = CHR(255, 75) OR  joy_dir = joy_left ) AND menu_column = 1 THEN menu_column = 0: mysound.FMOD_is_disabled = FALSE: mysound.play_SFX(sfx_whack, channel_whack)
            IF (userinput = CHR(255, 77) OR  joy_dir = joy_right) AND menu_column = 0 THEN menu_column = 1: mysound.FMOD_is_disabled = TRUE : mysound.play_SFX(sfx_whack, channel_whack)

         CASE 1 'joy set action

            IF userinput = CHR(32) OR j1.button THEN
               LINE(0,0)-(639,479),&haf000000,bf
               LINE(100,200)-(639-100, 200+100), &h7fffffff,bf
               DRAW STRING (140,230), "Press any joypad button to set attack button", &hff000000
               DRAW STRING (140,260), "OR [Esc] to cancel" , &hff000000
               mysound.play_SFX(sfx_punch, channel_punch)
               IF j1.SET_BUTTON(stat.attack_button) THEN mysound.play_SFX(sfx_whack, channel_whack)
            END IF

         CASE 2 'joy set menu

            IF userinput = CHR(32) OR j1.button THEN
               LINE(0,0)-(639,479),&haf000000,bf
               LINE(100,200)-(639-100, 200+100), &h7fffffff,bf
               DRAW STRING (120,220), "Press any joypad button to set menu button", &hff000000
               DRAW STRING (120,250), "OR [Esc] to cancel" , &hff000000
               mysound.play_SFX(sfx_punch, channel_punch)
               IF j1.SET_BUTTON(stat.menu_button) THEN mysound.play_SFX(sfx_whack, channel_whack)
            END IF

         CASE 3 'joy default

            IF userinput = CHR(32) OR (j1.button AND NOT btn_hold) THEN
               btn_hold = true
               stat.attack_button = 0
               stat.menu_button = 9
               mysound.play_SFX(sfx_glass, channel_glass)
            END IF

         CASE 4 'back

            IF userinput = CHR(32) OR (j1.button AND NOT btn_hold) THEN
               btn_hold = true
               back = TRUE
               mysound.play_SFX(sfx_whack, channel_whack)
            END IF

      END SELECT

      SLEEP 10,1

   LOOP UNTIL back

   'pause until joypad button holding is done.
   DO
      j1.poll()
   LOOP while j1.button

   IMAGEDESTROY(t_option_menu)
   IMAGEDESTROY(t_on_off)

END SUB

SUB warning()

   DIM AS fb.image PTR t_blink, t_warning
   DIM AS INTEGER warn_ctr = 0, fade = &hff

   t_warning = BMPLOAD("gfx\warning.bmp")
   t_blink = BMPLOAD("gfx\blink.bmp")

   DO
      warn_ctr += 1

      #IFDEF debug_on
      IF INKEY=CHR(27) AND warn_ctr <= 240 THEN warn_ctr = 240
      #ENDIF

      SELECT CASE warn_ctr

         CASE IS < 20
            SCREENLOCK
            PUT(0,0), t_warning, PSET
            LINE(0,0)-(639,479), RGBA(0,0,0, fade), bf
            fade-= 16
            IF fade<=0 THEN fade = 0
            SCREENUNLOCK

         CASE 120,120+20
            PUT(289,173), t_blink,(0,1*41)-(68, 1*41+40),PSET '
         CASE 122,122+20
            PUT(289,173), t_blink,(0,2*41)-(68, 2*41+40),PSET
         CASE 134,134+20
            PUT(289,173), t_blink,(0,1*41)-(68, 1*41+40),PSET
         CASE 136,136+20, 240
            PUT(289,173), t_blink,(0,0*41)-(68, 0*41+40),PSET
         CASE IS >240
            LINE(0,0)-(639,479), &h1f000000,bf

      END select
      SLEEP 10,1

   LOOP UNTIL warn_ctr>300

   IMAGEDESTROY(t_blink)
   IMAGEDESTROY(t_warning)

END SUB
